/* $Id: answers.h,v 1.3 2000/11/17 14:56:21 ltd Exp $ */
#ifndef __ANSWERS_H__
#define __ANSWERS_H__

struct Answer {
	char *tag;
	char *value;
	
	Answer *next;

	Answer(const char *_tag, const char *_value);
	~Answer();

	void print();
};

class AnswerList {
	Answer *answers;

public:
	void Add(Answer *);
	void Clear();

	Answer *Head() const { return answers; }

	AnswerList();
	~AnswerList();
};

#endif
