/* $Id: itf.h,v 1.3 2000/11/17 14:56:21 ltd Exp $ */
#ifndef _debconfgui_H
#define _debconfgui_H

#include "questions.h"
#include "answers.h"

#define DEBCONF_OK		0
#define DEBCONF_GOBACK		30

class DebConfItf {
	friend class DebConfBackend;

protected:
	AnswerList answers;
	QuestionList questions;

public:
	virtual int AskQuestions() { return DEBCONF_OK; }
	virtual void SetTitle(char *) {};
	virtual void SetCapbBackup(bool) {};
	virtual void ClientConnected(int fd) {};

	virtual void Startup(){};
	virtual void Shutdown(){};

	DebConfItf() {};
	virtual ~DebConfItf() {};
};

#endif
