/* $Id: init_status.h,v 1.3 2000/11/17 14:56:21 ltd Exp $ */
#ifndef _curses_initprogress_H
#define _curses_initprogress_H

#include <ncurses.h>
#include <apt-pkg/progress.h>
#include "cursesui.h"

class CursesUI::InitStatus : public OpProgress
{ 
	protected: 
		WINDOW *wInitProgress;
		WINDOW *sInitProgress;
		bool NoUpdate;
		bool NoDisplay;
		virtual void Update();
		void InitWindows();
		void EndWindows();
		void UpdateTitle(const char *);

	public:
		virtual void Done();

		InitStatus(bool NoUpdate = false) : NoUpdate(NoUpdate), NoDisplay(false) {};
		InitStatus(Configuration & Config);
		virtual ~InitStatus();
};

#endif
