/* $Id: filteredit.h,v 1.1 2001/03/04 01:02:14 tausq Exp $ */
#ifndef _gtkui_filteredit_H
#define _gtkui_filteredit_H

#include "gtkui.h"

#include <list/filters.h>

#define NUM_FILTER_TYPES 7

class GtkUI::FilterEditor
{
	friend class GtkUI::Screen;
	
protected:

//	GtkUI &ui;
	GtkUI::Screen &screen;
	
	enum ObjectKey {
		Notebook,
		Column,
		Row,
		nKey
	};

	enum WidgetRow {
		And,
		Or,
		Menu,
		OptMenu,
		Extra,
		NRow
	};
	
	GtkWidget *dialog;
//old	GtkWidget *baselist;
//old	GtkWidget *filtertext;

//old	Filter::Target filters;

//old	int baserow, targetrow;
	bool cancelled;
//old	bool baseselected[NUM_FILTER_TYPES];
//old	bool targetselected[NUM_FILTER_TYPES];

	GtkWidget *CreateWidget();
//old	void UpdateLists();

	// static event handlers
	static void DoOK(GtkWidget *, gpointer);
	static void DoCancel(GtkWidget *, gpointer);
	static void MenuChange(gpointer, guint, GtkWidget *);
//old	static void SelectRow(GtkCList *, gint, gint, GdkEventButton *, gpointer);
//old	static void UnselectRow(GtkCList *, gint, gint, GdkEventButton *, gpointer);
//old	static void UpdateDisplay(GtkCList *, gint, gint, GdkEventButton *, gpointer);


	void filter_list_create();
	void UpdateFilterMenu(const char**, int);

public:
//old	FilterEditor(GtkUI &);
	FilterEditor(GtkUI::Screen &);
	~FilterEditor();

	bool Run();
//old	void GetFilter(char *&filtertext, Filter::Target &target);
	void GetFilter(char **, unsigned long *);
	SortOrderList::method_t GetFilterType();
};

#endif
