/* $Id: progress.cc,v 1.4 2000/11/17 14:56:21 ltd Exp $ */

//old #include <std.h>
#include "progress.h"
#include "util.h"

#include "pixmaps/edeity.xpm"

#include <apt-pkg/configuration.h>


using namespace GtkUtil;

GtkUI::ProgressBar::ProgressBar()
{
	_splashwin = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_position(GTK_WINDOW(_splashwin), GTK_WIN_POS_CENTER);
	//gtk_window_set_title(GTK_WINDOW(_dialog), "Starting EDeity");
	//gtk_window_set_default_size(GTK_WINDOW(_dialog), 300, -1);
	gtk_widget_realize(_splashwin);
	gtk_window_set_decorated(GTK_WINDOW(_splashwin), FALSE);
	gtk_window_set_modal(GTK_WINDOW(_splashwin), TRUE);
	
	_vbox = gtk_vbox_new(FALSE, 0);
//	gtk_widget_show(_vbox);

	gtk_container_add(GTK_CONTAINER(_splashwin), _vbox);

//old	GtkWidget *splashpix = ImageFromXPM(edeity_xpm);
	GtkWidget *splashpix = ImageFromXPM(edeity_xpm, NULL);
//	gtk_widget_show(splashpix);

	_label = gtk_label_new(_("Reading Package Cache"));

	_bar = gtk_progress_bar_new();
//	gtk_progress_bar_set_bar_style(GTK_PROGRESS_BAR(_bar), GTK_PROGRESS_CONTINUOUS);
	gtk_progress_bar_set_orientation(GTK_PROGRESS_BAR(_bar), GTK_PROGRESS_LEFT_TO_RIGHT);
//	gtk_progress_set_show_text(GTK_PROGRESS(_bar), TRUE);

	gtk_box_pack_start (GTK_BOX(_vbox), splashpix, FALSE, FALSE, 0);
	gtk_box_pack_start (GTK_BOX(_vbox), _label, FALSE, FALSE, 0);
	gtk_box_pack_start (GTK_BOX(_vbox), _bar, FALSE, FALSE, 0);

	gtk_container_set_border_width(GTK_CONTAINER(_splashwin), 0);

	gtk_widget_show_all(_splashwin);
}

GtkUI::ProgressBar::~ProgressBar()
{
//	gtk_progress_bar_update(GTK_PROGRESS_BAR(_bar), 1.0);
	gtk_progress_set_percentage(GTK_PROGRESS(_bar), 1.0);

	while (gtk_events_pending())
		gtk_main_iteration();

	gtk_widget_destroy(_splashwin);
}

void GtkUI::ProgressBar::Update()
{
	if (CheckChange() == false)
		return;

//	gtk_progress_bar_update(GTK_PROGRESS_BAR(_bar), Percent / 100);
	gtk_progress_set_percentage(GTK_PROGRESS(_bar), Percent / 100);
//	gtk_progress_set_format_string(GTK_PROGRESS(_bar), SubOp.c_str());
	gtk_progress_bar_set_text(GTK_PROGRESS_BAR(_bar), SubOp.c_str());
	if (MajorChange)
//		gtk_label_set(GTK_LABEL(_label), Op.c_str());
		gtk_label_set_text(GTK_LABEL(_label), Op.c_str());

	while (gtk_events_pending())
		gtk_main_iteration();
}

void GtkUI::ProgressBar::Done()
{
//	gtk_progress_bar_update(GTK_PROGRESS_BAR(_bar), 0.0);
	gtk_progress_set_percentage(GTK_PROGRESS(_bar), 0.0);
}
