/* $Id: sortui.cc,v 1.9 2000/11/17 14:56:21 ltd Exp $ */
//old #include <std.h>
#include "sortui.h"
#include "pkgtreewidget.h"
#include "screen.h"


/*old
GtkUI::SortUI::SortUI(GtkUI::Screen &_screen)
	: screen(_screen), window(0), srcrow(-1), dstrow(-1)
{
	gchar *title = "Method";
	gchar *methods[] = { 
		"Name", 
		"Priority",
		"Status", 
		"Archive size", 
		"Installed size", 
		"Type/Section/Area", 
		"Distribution",
		"Suite" };

	window = gtk_window_new(GTK_WINDOW_DIALOG);
	gtk_window_set_title(GTK_WINDOW(window), "Set Sort Methods");
	gtk_window_set_position(GTK_WINDOW(window), GTK_WIN_POS_CENTER);
	gtk_window_set_modal(GTK_WINDOW(window), TRUE);

	GtkWidget *vbox = gtk_vbox_new(FALSE, 7);
	gtk_container_add(GTK_CONTAINER(window), vbox);
	gtk_container_set_border_width(GTK_CONTAINER(vbox), 20);

	GtkWidget *hbox = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, TRUE, 0);

	srclist = gtk_clist_new_with_titles(1, &title);
	gtk_clist_set_shadow_type (GTK_CLIST(srclist), GTK_SHADOW_OUT);
	gtk_clist_set_column_width(GTK_CLIST(srclist), 0, 150);
	gtk_box_pack_start(GTK_BOX(hbox), srclist, TRUE, TRUE, 0);
	gtk_clist_set_auto_sort(GTK_CLIST(srclist), TRUE);
	gtk_signal_connect(GTK_OBJECT(srclist), "select-row",
		GTK_SIGNAL_FUNC(SelectSrcRow), (gpointer)this);
	gtk_signal_connect(GTK_OBJECT(srclist), "unselect-row",
		GTK_SIGNAL_FUNC(UnselectSrcRow), (gpointer)this);

	GtkWidget *vbox2 = gtk_vbox_new(TRUE, 0);
	gtk_box_pack_start(GTK_BOX(hbox), vbox2, FALSE, FALSE, 10);
	
	GtkWidget *btnadd = gtk_button_new_with_label("->");
	gtk_signal_connect(GTK_OBJECT(btnadd), "clicked",
		GTK_SIGNAL_FUNC(AddMethod), (gpointer)this);
	gtk_box_pack_start(GTK_BOX(vbox2), btnadd, FALSE, FALSE, 0);
	GtkWidget *btnremove = gtk_button_new_with_label("<-");
	gtk_signal_connect(GTK_OBJECT(btnremove), "clicked",
		GTK_SIGNAL_FUNC(RemoveMethod), (gpointer)this);
	gtk_box_pack_start(GTK_BOX(vbox2), btnremove, FALSE, FALSE, 0);
	GtkWidget *btnmoveup = gtk_button_new_with_label("Move Up");
	gtk_signal_connect(GTK_OBJECT(btnmoveup), "clicked",
		GTK_SIGNAL_FUNC(MoveUp), (gpointer)this);
	gtk_box_pack_start(GTK_BOX(vbox2), btnmoveup, FALSE, FALSE, 0);
	GtkWidget *btnmovedown = gtk_button_new_with_label("Move Down");
	gtk_signal_connect(GTK_OBJECT(btnmovedown), "clicked",
		GTK_SIGNAL_FUNC(MoveDown), (gpointer)this);
	gtk_box_pack_start(GTK_BOX(vbox2), btnmovedown, FALSE, FALSE, 0);

	dstlist = gtk_clist_new_with_titles(1, &title);
	gtk_clist_set_shadow_type (GTK_CLIST(dstlist), GTK_SHADOW_OUT);
	gtk_clist_set_column_width(GTK_CLIST(dstlist), 0, 150);
	gtk_box_pack_start(GTK_BOX(hbox), dstlist, TRUE, TRUE, 0);
	gtk_signal_connect(GTK_OBJECT(dstlist), "select-row",
		GTK_SIGNAL_FUNC(SelectDstRow), (gpointer)this);
	gtk_signal_connect(GTK_OBJECT(dstlist), "unselect-row",
		GTK_SIGNAL_FUNC(UnselectDstRow), (gpointer)this);

	GtkWidget *hbox2 = gtk_hbox_new(TRUE, 0);
	gtk_box_pack_start(GTK_BOX(vbox), hbox2, FALSE, FALSE, 0);
	gtk_container_set_border_width(GTK_CONTAINER(hbox2), 8);

	GtkWidget *btnapply = gtk_button_new_with_label("Apply");
	gtk_signal_connect(GTK_OBJECT(btnapply), "clicked",
		GTK_SIGNAL_FUNC(Apply), (gpointer)this);
	gtk_box_pack_start(GTK_BOX(hbox2), btnapply, TRUE, TRUE, 15);

	GtkWidget *btncancel = gtk_button_new_with_label("Cancel");
	gtk_signal_connect(GTK_OBJECT(btncancel), "clicked",
		GTK_SIGNAL_FUNC(Cancel), (gpointer)this);

	gtk_box_pack_end(GTK_BOX(hbox2), btncancel, TRUE, TRUE, 15);

	// Add the methods to the source list
	if (!screen.Packages->Sorting->Exists(SortOrderList::PkgName))
		gtk_clist_append(GTK_CLIST(srclist), &methods[0]);
	if (!screen.Packages->Sorting->Exists(SortOrderList::Priority))
		gtk_clist_append(GTK_CLIST(srclist), &methods[1]);
	if (!screen.Packages->Sorting->Exists(SortOrderList::Status))
		gtk_clist_append(GTK_CLIST(srclist), &methods[2]);
	if (!screen.Packages->Sorting->Exists(SortOrderList::Size))
		gtk_clist_append(GTK_CLIST(srclist), &methods[3]);
	if (!screen.Packages->Sorting->Exists(SortOrderList::Instsize))
		gtk_clist_append(GTK_CLIST(srclist), &methods[4]);
	if (!screen.Packages->Sorting->Exists(SortOrderList::Section))
		gtk_clist_append(GTK_CLIST(srclist), &methods[5]);
	if (!screen.Packages->Sorting->Exists(SortOrderList::Distribution))
		gtk_clist_append(GTK_CLIST(srclist), &methods[6]);
	if (!screen.Packages->Sorting->Exists(SortOrderList::Suite))
		gtk_clist_append(GTK_CLIST(srclist), &methods[7]);

	// Add already installed methods to the destination list
	for (SortOrderList::SortIterator S = screen.Packages->Sorting->ListBegin(); S.end() == false; S++)
	{
		switch (S.method())
		{
		case SortOrderList::PkgName:
			gtk_clist_append(GTK_CLIST(dstlist), &methods[0]);
			break;
		case SortOrderList::Priority:
			gtk_clist_append(GTK_CLIST(dstlist), &methods[1]);
			break;
		case SortOrderList::Status:
			gtk_clist_append(GTK_CLIST(dstlist), &methods[2]);
			break;
		case SortOrderList::Size:
			gtk_clist_append(GTK_CLIST(dstlist), &methods[3]);
			break;
		case SortOrderList::Instsize:
			gtk_clist_append(GTK_CLIST(dstlist), &methods[4]);
			break;
		case SortOrderList::Section:
			gtk_clist_append(GTK_CLIST(dstlist), &methods[5]);
			break;
		case SortOrderList::Distribution:
			gtk_clist_append(GTK_CLIST(dstlist), &methods[6]);
			break;
		case SortOrderList::Suite:
			gtk_clist_append(GTK_CLIST(dstlist), &methods[7]);
			break;
		}
	}

}
*/
void GtkUI::SortUI::Invert (GtkCellRendererToggle *renderer, gchar *arg1, gpointer data)
{
	GtkUI::SortUI *This = (GtkUI::SortUI *)data;
	
	GtkTreeIter iter;
	GtkTreeModel *model;
	GtkTreeSelection *select = gtk_tree_view_get_selection (GTK_TREE_VIEW (This->dstlist));
	
	if (gtk_tree_selection_get_selected (select, &model, &iter))
	{
	    gtk_list_store_set (This->dstliststore, &iter, 
				Invert_Col, !gtk_cell_renderer_toggle_get_active (renderer),
				-1);
	}
}

void GtkUI::SortUI::DragAndDrop (GtkWidget *dstwidget, GdkDragContext *dc, gint x, gint y, GtkSelectionData *selection_data, guint info, guint t, gpointer data)
{
	GtkTreePath *path = NULL;
	GtkTreeModel *model;
        GtkTreeSelection *select;
	GtkTreeIter dstiter, srciter;
	GtkTreeViewDropPosition pos;
	
	GtkWidget *srcwidget = gtk_drag_get_source_widget (dc);
	GtkTreeModel *srcmodel = gtk_tree_view_get_model (GTK_TREE_VIEW (srcwidget));
	
	GtkTreeModel *dstmodel = gtk_tree_view_get_model (GTK_TREE_VIEW (dstwidget));
	        
	if (gtk_tree_view_get_dest_row_at_pos (GTK_TREE_VIEW (dstwidget), x, y, &path, &pos))
	    if (gtk_tree_model_get_iter (dstmodel, &dstiter, path))
	    {
		GtkTreeIter iter;
		gchar *name;
		gint num;
	    
		select = gtk_tree_view_get_selection (GTK_TREE_VIEW (srcwidget));
		gtk_tree_selection_get_selected (select, &model, &srciter);
		    gtk_tree_model_get (srcmodel, &srciter,
					Name_Col, &name,
					Num_Col, &num,
					-1);
		    								 
		    switch (pos)
		    {
			case GTK_TREE_VIEW_DROP_BEFORE:
			case GTK_TREE_VIEW_DROP_INTO_OR_BEFORE:
			    gtk_list_store_insert_before (GTK_LIST_STORE (dstmodel), &iter, &dstiter);
			    break;
			    
			case GTK_TREE_VIEW_DROP_AFTER:
			case GTK_TREE_VIEW_DROP_INTO_OR_AFTER:
			    gtk_list_store_insert_after (GTK_LIST_STORE (dstmodel), &iter, &dstiter);
			    break;
			    
			default:
			    break;
		    }
		    gtk_list_store_set (GTK_LIST_STORE (dstmodel), &iter,
					Name_Col, name,
					Num_Col, num,
					-1);
		    
		    gtk_list_store_remove (GTK_LIST_STORE (srcmodel), &srciter);
	    }
}

GtkUI::SortUI::SortUI(GtkUI::Screen &_screen)
	: screen(_screen)//, window(0), srcrow(-1), dstrow(-1)
{
	gchar *title = _("Method");
/*	gchar *methods[] = { 
		"Name", 
		"Priority",
		"Status", 
		"Archive size", 
		"Installed size", 
		"Type/Section/Area", 
		"Filename",
		"Suite" };
*/

	gchar *methods[screen.Packages->Sorting->TotalLength()];
	
	methods[screen.Packages->Sorting->PkgName] = _("Name");
	methods[screen.Packages->Sorting->Priority] = _("Priority");
	methods[screen.Packages->Sorting->Status] = _("Status");
	methods[screen.Packages->Sorting->SpecStat] = _("Specified stat.");
	methods[screen.Packages->Sorting->Size] = _("Archive size");
	methods[screen.Packages->Sorting->Instsize] = _("Installed size");
	methods[screen.Packages->Sorting->Section] = _("Type/Section/Area");
	methods[screen.Packages->Sorting->Filename] = _("Filename");
	methods[screen.Packages->Sorting->Suite] = _("Suite");
	methods[screen.Packages->Sorting->Dep] = _("Dependency");
	methods[screen.Packages->Sorting->RevDep] = _("Rev. Dependency");
	
		
	GtkTreeSelection *select;
	GtkTreeIter iter;
	GtkCellRenderer *renderer;
	GtkTreeViewColumn *column;
	GtkTargetEntry SrcEntry;


	srcliststore = gtk_list_store_new(N_Col - 1, 
					  G_TYPE_STRING,
					  G_TYPE_INT);
					  
	// Add the methods to the source list
	for (int i = 1; i < screen.Packages->Sorting->TotalLength(); i++)
		if (!screen.Packages->Sorting->Exists(SortOrderList::method_t (i)))
		{
			gtk_list_store_append(srcliststore, &iter);
			gtk_list_store_set(srcliststore, &iter, 
			    		   Name_Col, methods[i],
					   Num_Col, i,
				           -1);
		}
		
	srclist = gtk_tree_view_new_with_model (GTK_TREE_MODEL(srcliststore));
	gtk_tree_view_enable_model_drag_dest (GTK_TREE_VIEW (srclist), &SrcEntry, 1, GDK_ACTION_MOVE);
	gtk_tree_view_enable_model_drag_source (GTK_TREE_VIEW (srclist), GDK_BUTTON1_MASK, &SrcEntry, 1, GDK_ACTION_MOVE);
	g_signal_connect(GTK_OBJECT (srclist), "drag_data_received", G_CALLBACK(DragAndDrop), (gpointer)this);
	
	select = gtk_tree_view_get_selection (GTK_TREE_VIEW(srclist));
	gtk_tree_selection_set_mode (select, GTK_SELECTION_SINGLE);

/*old	g_signal_connect(G_OBJECT(select), "select-row",
		G_CALLBACK(SelectSrcRow), (gpointer)this);
	g_signal_connect(G_OBJECT(select), "unselect-row",
		G_CALLBACK(UnselectSrcRow), (gpointer)this);
*/
	
	renderer = gtk_cell_renderer_text_new ();
	column = gtk_tree_view_column_new_with_attributes (title, renderer, "text", Name_Col, NULL);
	gtk_tree_view_column_set_clickable (column, FALSE);	
	gtk_tree_view_column_set_sort_column_id (column, 0);
	gtk_tree_view_column_set_min_width (column, 150);
		
	gtk_tree_view_append_column (GTK_TREE_VIEW (srclist), column);

	dstliststore = gtk_list_store_new(N_Col,
					  G_TYPE_STRING,
					  G_TYPE_INT,
					  G_TYPE_BOOLEAN);
	

	// Add already installed methods to the destination list
	for (SortOrderList::SortIterator S = screen.Packages->Sorting->ListBegin(); S.end() == false; S++)
	if (S.method() != SortOrderList::SpecStat)
	{
		gtk_list_store_append(dstliststore, &iter);
		gtk_list_store_set(dstliststore, &iter,
			           Name_Col, methods[S.method()],
					   Num_Col, S.method(),
			           Invert_Col, false,
			           -1);
	}
	
	dstlist = gtk_tree_view_new_with_model (GTK_TREE_MODEL(dstliststore));
	gtk_tree_view_enable_model_drag_dest (GTK_TREE_VIEW (dstlist), &SrcEntry, 1, GDK_ACTION_MOVE);
	gtk_tree_view_enable_model_drag_source (GTK_TREE_VIEW (dstlist), GDK_BUTTON1_MASK, &SrcEntry, 1, GDK_ACTION_MOVE);
	g_signal_connect(GTK_OBJECT(dstlist), "drag_data_received", G_CALLBACK(DragAndDrop), (gpointer)this);
	
	select = gtk_tree_view_get_selection (GTK_TREE_VIEW(dstlist));
	
	renderer = gtk_cell_renderer_text_new ();
	column = gtk_tree_view_column_new_with_attributes (title, renderer, "text", Name_Col, NULL);
	gtk_tree_view_column_set_min_width (column, 150);
	
	gtk_tree_view_append_column (GTK_TREE_VIEW (dstlist), column);

	renderer = gtk_cell_renderer_toggle_new ();
	g_signal_connect (G_OBJECT (renderer), "toggled", G_CALLBACK (Invert), gpointer (this));
	
	column = gtk_tree_view_column_new_with_attributes (_("Inv."), renderer, "active", Invert_Col, NULL);
	gtk_tree_view_column_set_min_width (column, 20);
	
	gtk_tree_view_append_column (GTK_TREE_VIEW (dstlist), column);


	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW(window), _("Set Sort Methods"));
	gtk_window_set_position(GTK_WINDOW(window), GTK_WIN_POS_CENTER_ON_PARENT);
	gtk_window_set_modal(GTK_WINDOW(window), TRUE);

	GtkWidget *vbox = gtk_vbox_new(FALSE, 7);
	gtk_container_add(GTK_CONTAINER(window), vbox);
	gtk_container_set_border_width(GTK_CONTAINER(vbox), 20);

	GtkWidget *hbox = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, TRUE, 0);

	gtk_box_pack_start(GTK_BOX(hbox), srclist, TRUE, TRUE, 0);

	GtkWidget *vbox2 = gtk_vbox_new(TRUE, 0);
	gtk_box_pack_start(GTK_BOX(hbox), vbox2, FALSE, FALSE, 10);
	
	GtkWidget *btnadd = gtk_button_new_with_label("->");
	g_signal_connect(G_OBJECT(btnadd), "clicked", G_CALLBACK(AddMethod), (gpointer)this);
	gtk_box_pack_start(GTK_BOX(vbox2), btnadd, FALSE, FALSE, 0);
	
	GtkWidget *btnremove = gtk_button_new_with_label("<-");
	g_signal_connect(G_OBJECT(btnremove), "clicked", G_CALLBACK(RemoveMethod), (gpointer)this);
	gtk_box_pack_start(GTK_BOX(vbox2), btnremove, FALSE, FALSE, 0);
	
	GtkWidget *btnmoveup = gtk_button_new_with_label(_("Move Up"));
	g_signal_connect(G_OBJECT(btnmoveup), "clicked", G_CALLBACK(MoveUp), (gpointer)this);
	gtk_box_pack_start(GTK_BOX(vbox2), btnmoveup, FALSE, FALSE, 0);
	
	GtkWidget *btnmovedown = gtk_button_new_with_label(_("Move Down"));
	g_signal_connect(G_OBJECT(btnmovedown), "clicked", G_CALLBACK(MoveDown), (gpointer)this);
	gtk_box_pack_start(GTK_BOX(vbox2), btnmovedown, FALSE, FALSE, 0);


	gtk_box_pack_start(GTK_BOX(hbox), dstlist, TRUE, TRUE, 0);
/*old	gtk_signal_connect(GTK_OBJECT(dstlist), "select-row",
		GTK_SIGNAL_FUNC(SelectDstRow), (gpointer)this);
	gtk_signal_connect(GTK_OBJECT(dstlist), "unselect-row",
		GTK_SIGNAL_FUNC(UnselectDstRow), (gpointer)this);
*/
	GtkWidget *hbox2 = gtk_hbox_new(TRUE, 0);
	gtk_box_pack_start(GTK_BOX(vbox), hbox2, FALSE, FALSE, 0);
	gtk_container_set_border_width(GTK_CONTAINER(hbox2), 8);

	GtkWidget *btnapply = gtk_button_new_with_label(_("Apply"));
	g_signal_connect(GTK_OBJECT(btnapply), "clicked", G_CALLBACK(Apply), (gpointer)this);
	gtk_box_pack_start(GTK_BOX(hbox2), btnapply, TRUE, TRUE, 15);

	GtkWidget *btncancel = gtk_button_new_with_label(_("Cancel"));
	g_signal_connect(G_OBJECT(btncancel), "clicked", G_CALLBACK(Cancel), (gpointer)this);
		
	gtk_box_pack_end(GTK_BOX(hbox2), btncancel, TRUE, TRUE, 15);

}

GtkUI::SortUI::~SortUI()
{
	if (window)
		gtk_widget_destroy(window);
	window = 0;
}

void GtkUI::SortUI::Show()
{
	gtk_widget_show_all(window);
	// enter local event loop
	gtk_main();
}

void GtkUI::SortUI::AddMethod(GtkWidget *widget, gpointer data)
{
	GtkTreeIter srciter, dstiter;
        GtkTreeModel *model;
	GtkTreeSelection *select;
	
	gchar *method;
	gint num;
	
	GtkUI::SortUI *ui = (GtkUI::SortUI *)data;
/*	if (ui->srcrow < 0) return;

	gchar *text;
	gtk_clist_get_text(GTK_CLIST(ui->srclist), ui->srcrow, 0, &text);
	gtk_clist_append(GTK_CLIST(ui->dstlist), &text);
	gtk_clist_remove(GTK_CLIST(ui->srclist), ui->srcrow);
*/
	select = gtk_tree_view_get_selection (GTK_TREE_VIEW(ui->srclist));

	if (gtk_tree_selection_get_selected (select, &model, &srciter))
        {
	    gtk_tree_model_get (model, &srciter,
							Name_Col, &method,
							Num_Col, &num,
							-1);
	    gtk_list_store_insert_after (ui->dstliststore, &dstiter, NULL);
	    gtk_list_store_set(ui->dstliststore, &dstiter, 
						   Name_Col, method,
						   Num_Col, num,
						   -1);
	    
	    gtk_tree_selection_get_selected (select, &model, &srciter);
	    gtk_list_store_remove (ui->srcliststore, &srciter);

	    select = gtk_tree_view_get_selection (GTK_TREE_VIEW(ui->dstlist));
	    gtk_tree_model_get_iter_first (GTK_TREE_MODEL(ui->dstliststore), &dstiter);
	    gtk_tree_selection_select_iter (select, &dstiter);
        }
}

void GtkUI::SortUI::RemoveMethod(GtkWidget *widget, gpointer data)
{
	GtkTreeIter srciter, dstiter;
        GtkTreeModel *model;
	GtkTreeSelection *select;
	
	gchar *method;
	gchar num;
	
	GtkUI::SortUI *ui = (GtkUI::SortUI *)data;
/*old	if (ui->dstrow < 0) return;

	gchar *text;
	gtk_clist_get_text(GTK_CLIST(ui->dstlist), ui->dstrow, 0,
		&text);
	gtk_clist_append(GTK_CLIST(ui->srclist), &text);
	gtk_clist_remove(GTK_CLIST(ui->dstlist), ui->dstrow);
*/	
	select = gtk_tree_view_get_selection (GTK_TREE_VIEW(ui->dstlist));

	if (gtk_tree_selection_get_selected (select, &model, &dstiter))
        {
	    gtk_tree_model_get (model, &dstiter,
							Name_Col, &method,
							Num_Col, &num,
							-1);
	    gtk_list_store_insert_after (ui->srcliststore, &srciter, NULL);
	    gtk_list_store_set(ui->srcliststore, &srciter,
						   Name_Col, method,
						   Num_Col, num,
						   -1);
	    
	    gtk_list_store_remove (ui->dstliststore, &dstiter);
        }
}

void GtkUI::SortUI::MoveDown(GtkWidget *widget, gpointer data)
{
	GtkTreeIter srciter;
        GtkTreeModel *model;
	GtkTreeSelection *select;
	
//old	gchar *method;

	GtkUI::SortUI *ui = (GtkUI::SortUI *)data;
/*old	if (ui->dstrow < 1) return;
	gtk_clist_swap_rows(GTK_CLIST(ui->dstlist), ui->dstrow, ui->dstrow-1);
	ui->dstrow--;
*/
	select = gtk_tree_view_get_selection (GTK_TREE_VIEW(ui->dstlist));

	if (gtk_tree_selection_get_selected (select, &model, &srciter))
        {
/*	    GtkTreeIter *dtriter;
	
	    dstiter = gtk_tree_iter_copy (&srciter);
	    
	    if (gtk_tree_model_iter_next (model, &srciter))
		gtk_list_store_swap (ui->dstliststore, dstiter, &srciter);
		
	    gtk_tree_iter_free (dstiter);*/
	    
	    GtkTreeIter dstiter;
	    
	    gint num;
	    gboolean inv;
	    gchar* method;

	    gtk_tree_model_get (model, &srciter,
			       Name_Col, &method,
		    	       Num_Col, &num,
			       Invert_Col, &inv,
			       -1);
			       
	    if (gtk_tree_model_iter_next (model, &srciter))
	    {
	    
		gtk_list_store_insert_after (ui->dstliststore, &dstiter, &srciter);
		gtk_list_store_set(ui->dstliststore, &dstiter,
				   Name_Col, method,
			           Num_Col, num,
				   Invert_Col, inv,
				   -1);
				   
	    
		gtk_tree_selection_get_selected (select, &model, &srciter);
		gtk_list_store_remove (ui->dstliststore, &srciter);
		
		gtk_tree_selection_select_iter (select, &dstiter);		
	    }
        }
}

void GtkUI::SortUI::MoveUp(GtkWidget *widget, gpointer data)
{
	GtkTreeIter srciter, dstiter;
        GtkTreeModel *model;
	GtkTreeSelection *select;
	GtkTreePath *path;
	
	GtkUI::SortUI *ui = (GtkUI::SortUI *)data;
/*	gchar *dummy;
	if (ui->dstrow < 0) return;
	if (gtk_clist_get_text(GTK_CLIST(ui->dstlist), ui->dstrow+1, 0, &dummy) == 0) return;
	// should check to see if this is the last row too...
	gtk_clist_swap_rows(GTK_CLIST(ui->dstlist), ui->dstrow, ui->dstrow+1);
	ui->dstrow++;

*/	select = gtk_tree_view_get_selection (GTK_TREE_VIEW(ui->dstlist));

	if (gtk_tree_selection_get_selected (select, &model, &srciter))
	{
/*	    path = gtk_tree_model_get_path (model, &srciter);
	    if (gtk_tree_path_prev (path))
    	    {
		gtk_tree_model_get_iter (model, &dstiter, path);
		gtk_list_store_swap (ui->dstliststore, &dstiter, &srciter);
	    }*/
	    
	    gint num;
	    gboolean inv;
	    gchar* method;

	    gtk_tree_model_get (model, &srciter,
				Name_Col, &method,
			        Num_Col, &num,
				Invert_Col, &inv,
				-1);
				
	    path = gtk_tree_model_get_path (model, &srciter);
	    if (gtk_tree_path_prev (path))
    	    {
		gtk_tree_model_get_iter (model, &srciter, path);
	    	gtk_list_store_insert_before (ui->dstliststore, &dstiter, &srciter);
		gtk_list_store_set(ui->dstliststore, &dstiter,
				   Name_Col, method,
			           Num_Col, num,
				   Invert_Col, inv,
				   -1);
		
		gtk_tree_selection_get_selected (select, &model, &srciter);
		gtk_list_store_remove (ui->dstliststore, &srciter);
		
		gtk_tree_selection_select_iter (select, &dstiter);
	    }
	}    
}

void GtkUI::SortUI::Apply(GtkWidget *, gpointer data)
{
	GtkTreeIter iter;

	GtkUI::SortUI *ui = (GtkUI::SortUI *)data;
	gint num;
	gboolean inv;

	ui->screen.Packages->Sorting->Flush();
	
	
	if (gtk_tree_model_get_iter_first (GTK_TREE_MODEL(ui->dstliststore), &iter))
//	for (int i = 0; gtk_clist_get_text(GTK_CLIST(ui->dstlist), i, 0, &txt) != 0; i++) {
	    do{
		gtk_tree_model_get (GTK_TREE_MODEL(ui->dstliststore), &iter,
				    Num_Col, &num,
				    Invert_Col, &inv,
 				    -1);

		ui->screen.Packages->Sorting->Push(SortOrderList::method_t (num), inv);
	    }while (gtk_tree_model_iter_next (GTK_TREE_MODEL(ui->dstliststore), &iter));

	gtk_main_quit();
	gtk_widget_hide(ui->window);

	ui->screen.Packages->reinitialize();
	ui->screen.InvalidateIterators();
	ui->screen.BoundsReset();
	ui->screen.pkgtree->Redraw();
}

void GtkUI::SortUI::Cancel(GtkWidget *, gpointer data)
{
	GtkUI::SortUI *ui = (GtkUI::SortUI *)data;
	gtk_main_quit();
	gtk_widget_hide(ui->window);
}
/*old
void GtkUI::SortUI::SelectSrcRow(GtkCList *list, gint row, gint col, GdkEventButton *btn, gpointer data)
{
	GtkUI::SortUI *This = (GtkUI::SortUI *)data;
	This->srcrow = row;
}

void GtkUI::SortUI::UnselectSrcRow(GtkCList *list, gint row, gint col, GdkEventButton *btn, gpointer data)
{
	GtkUI::SortUI *This = (GtkUI::SortUI *)data;
	This->srcrow = -1;
}

void GtkUI::SortUI::SelectDstRow(GtkCList *list, gint row, gint col, GdkEventButton *btn, gpointer data)
{
	GtkUI::SortUI *This = (GtkUI::SortUI *)data;
	This->dstrow = row;
}

void GtkUI::SortUI::UnselectDstRow(GtkCList *list, gint row, gint col, GdkEventButton *btn, gpointer data)
{
	GtkUI::SortUI *This = (GtkUI::SortUI *)data;
	This->dstrow = -1;
}
*/
