/* $Id: sortui.h,v 1.3 2000/11/17 14:56:21 ltd Exp $ */
#ifndef _gtkui_sortui_H
#define _gtkui_sortui_H

#include "gtkui.h"

class GtkUI::SortUI
{
protected:
	GtkUI::Screen &screen;

	GtkWidget *window;
	GtkWidget *srclist;
	GtkWidget *dstlist;
	GtkListStore *srcliststore;
	GtkListStore *dstliststore;

	enum
	{
	    Name_Col,
	    Num_Col,
	    Invert_Col,
	    N_Col
	};
	
	static void AddMethod(GtkWidget *, gpointer);
	static void RemoveMethod(GtkWidget *, gpointer);
	static void MoveUp(GtkWidget *, gpointer);
	static void MoveDown(GtkWidget *, gpointer);
	static void Apply(GtkWidget *, gpointer);
	static void Cancel(GtkWidget *, gpointer);
	
	static void DragAndDrop (GtkWidget *, GdkDragContext *, gint, gint, GtkSelectionData *, guint, guint, gpointer);
	static void Invert (GtkCellRendererToggle *, gchar *, gpointer);
/*old
	static void SelectSrcRow(GtkCList *, gint, gint, GdkEventButton *, gpointer);
	static void UnselectSrcRow(GtkCList *, gint, gint, GdkEventButton *, gpointer);
	static void SelectDstRow(GtkCList *, gint, gint, GdkEventButton *, gpointer);
	static void UnselectDstRow(GtkCList *, gint, gint, GdkEventButton *, gpointer);
	int srcrow, dstrow;
*/	
public:
	SortUI(GtkUI::Screen &);
	~SortUI();

	void Show();
};

#endif
