/* $Id: srcedit.cc,v 1.4 2001/02/23 05:53:30 tausq Exp $ */
//old #include <std.h>
#include "srcedit.h"

#define ITEM_TYPE_DEB		0
#define ITEM_TYPE_DEBSRC	1

GtkUI::SrcEditor::SrcEditor(GtkUI::Screen &_screen) : screen(_screen)
{
//old	selectedrow = -1;
	isRoot = (getuid() == 0);
	dialog = CreateWidget();
}

GtkUI::SrcEditor::~SrcEditor()
{
	gtk_widget_destroy(dialog);
}

GtkWidget *GtkUI::SrcEditor::CreateWidget()
{
	GtkWidget *dlgSrcList;
	GtkWidget *dialog_vbox1;
	GtkWidget *frmMain;
	GtkWidget *vbox1;
	GtkWidget *scrolledwindow1;
/*old	GtkWidget *lblLstStatus;
	GtkWidget *lblLstType;
	GtkWidget *lblLstURI;
	GtkWidget *lblLstDist;
	GtkWidget *lblLstSection;
*/	GtkWidget *hbox2;
	GtkWidget *btnAddNew;
	GtkWidget *btnEdit;
	GtkWidget *btnRemove;
	GtkWidget *table1;
	GtkWidget *lblStatus;
	GtkWidget *lblType;
	GtkWidget *lblURI;
	GtkWidget *item;
	GtkWidget *table2;
	GtkWidget *lblDist;
	GtkWidget *lblSection;
	GtkWidget *hbox3;
	GtkWidget *lblSectother;
	GtkWidget *comDist;
	GList *comDist_items = NULL;
	GtkWidget *dialog_action_area1;
	GtkWidget *hbox1;
	GtkWidget *btnOK;
	GtkWidget *btnCancel;
	
	GtkTreeSelection *select;
	GtkTreeViewColumn *column;
	GtkCellRenderer *renderer;

	GtkItemFactory *itemfact;
	static GtkItemFactoryEntry items[] = {
	    { _("/deb"),		NULL,	NULL,	ITEM_TYPE_DEB,		"<Item>" },
	    { _("/deb-src"),	NULL,	NULL,	ITEM_TYPE_DEBSRC,	"<Item>" },
	};

	gchar *columns[ColumnNum - 2];
	
	columns[Active_Col] = _("Status");
	columns[DebType_Col] = _("Type");
	columns[URI_Col] = _("URI");
	columns[Distrib_Col] = _("Distribution");
	columns[Section_Col] = _("Section(s)");
	
	dlgSrcList = gtk_dialog_new ();
	gtk_window_set_title (GTK_WINDOW (dlgSrcList), _("APT sources.list editor"));
//old	GTK_WINDOW (dlgSrcList)->type = GTK_WINDOW_DIALOG;
	GTK_WINDOW (dlgSrcList)->type = GTK_WINDOW_TOPLEVEL;
	gtk_window_set_modal (GTK_WINDOW (dlgSrcList), TRUE);
	gtk_window_set_default_size (GTK_WINDOW (dlgSrcList), -1, 400);
	gtk_window_set_policy (GTK_WINDOW (dlgSrcList), TRUE, TRUE, FALSE);

	dialog_vbox1 = GTK_DIALOG (dlgSrcList)->vbox;
	gtk_widget_show (dialog_vbox1);

	frmMain = gtk_frame_new (NULL);
	gtk_widget_show (frmMain);
	gtk_box_pack_start (GTK_BOX (dialog_vbox1), frmMain, TRUE, TRUE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (frmMain), 5);

	vbox1 = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox1);
	gtk_container_add (GTK_CONTAINER (frmMain), vbox1);
	gtk_container_set_border_width (GTK_CONTAINER (vbox1), 5);

	scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
	gtk_widget_show (scrolledwindow1);
	gtk_box_pack_start (GTK_BOX (vbox1), scrolledwindow1, TRUE, TRUE, 0);

//old	lstSources = gtk_clist_new (5);
	lstSourcesstore = gtk_list_store_new (ColumnNum, 
					      G_TYPE_STRING,
					      G_TYPE_STRING,
					      G_TYPE_STRING,
					      G_TYPE_STRING,
 					      G_TYPE_STRING,
 					      G_TYPE_STRING,
					      G_TYPE_POINTER);
					      
	lstSources = gtk_tree_view_new_with_model (GTK_TREE_MODEL(lstSourcesstore));
	select = gtk_tree_view_get_selection (GTK_TREE_VIEW(lstSources));
	gtk_tree_selection_set_mode (select, GTK_SELECTION_SINGLE);


	for (int i = 0; i < ColumnNum - 2; i++)
	{
		renderer = gtk_cell_renderer_text_new ();
		column = gtk_tree_view_column_new_with_attributes (columns[i], renderer, "text", i, NULL);

		if (GTK_MAJOR_VERSION == 2 && GTK_MINOR_VERSION)							   
				gtk_tree_view_column_add_attribute (column, renderer,
													"cell-background", Color_Col);

	    gtk_tree_view_column_set_resizable (column, TRUE);
	    gtk_tree_view_column_set_sizing (column, GTK_TREE_VIEW_COLUMN_AUTOSIZE);

	gtk_tree_view_append_column (GTK_TREE_VIEW (lstSources), column);
	}

	gtk_container_add (GTK_CONTAINER (scrolledwindow1), lstSources);
/*old	gtk_widget_show (lstSources);
	gtk_clist_set_column_width (GTK_CLIST (lstSources), 0, 61);
	gtk_clist_set_column_width (GTK_CLIST (lstSources), 1, 71);
	gtk_clist_set_column_width (GTK_CLIST (lstSources), 2, 365);
	gtk_clist_set_column_width (GTK_CLIST (lstSources), 3, 70);
	gtk_clist_set_column_width (GTK_CLIST (lstSources), 4, 80);
	gtk_clist_column_titles_show (GTK_CLIST (lstSources));

	lblLstStatus = gtk_label_new ("Status");
	gtk_widget_show (lblLstStatus);
	gtk_clist_set_column_widget (GTK_CLIST (lstSources), 0, lblLstStatus);

	lblLstType = gtk_label_new ("Type");
	gtk_widget_show (lblLstType);
	gtk_clist_set_column_widget (GTK_CLIST (lstSources), 1, lblLstType);

	lblLstURI = gtk_label_new ("URI");
	gtk_widget_show (lblLstURI);
	gtk_clist_set_column_widget (GTK_CLIST (lstSources), 2, lblLstURI);

	lblLstDist = gtk_label_new ("Distribution");
	gtk_widget_show (lblLstDist);
	gtk_clist_set_column_widget (GTK_CLIST (lstSources), 3, lblLstDist);

	lblLstSection = gtk_label_new ("Section(s)");
	gtk_widget_show (lblLstSection);
	gtk_clist_set_column_widget (GTK_CLIST (lstSources), 4, lblLstSection);
*/
	hbox2 = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox2);
	gtk_box_pack_start (GTK_BOX (vbox1), hbox2, FALSE, TRUE, 6);

	btnAddNew = gtk_button_new_with_label (_("Add new"));
	gtk_widget_show (btnAddNew);
	gtk_box_pack_start (GTK_BOX (hbox2), btnAddNew, TRUE, TRUE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (btnAddNew), 10);

	btnEdit = gtk_button_new_with_label (_("Update"));
	gtk_widget_show (btnEdit);
	gtk_box_pack_start (GTK_BOX (hbox2), btnEdit, TRUE, TRUE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (btnEdit), 10);

	btnRemove = gtk_button_new_with_label (_("Remove"));
	gtk_widget_show (btnRemove);
	gtk_box_pack_start (GTK_BOX (hbox2), btnRemove, TRUE, TRUE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (btnRemove), 10);

	table1 = gtk_table_new (2, 3, FALSE);
	gtk_widget_show (table1);
	gtk_box_pack_start (GTK_BOX (vbox1), table1, FALSE, TRUE, 0);
	gtk_container_set_border_width (GTK_CONTAINER (table1), 5);
	gtk_table_set_col_spacings (GTK_TABLE (table1), 10);

	lblStatus = gtk_label_new (_("Status"));
	gtk_widget_show (lblStatus);
	gtk_table_attach (GTK_TABLE (table1), lblStatus, 0, 1, 0, 1,
		    (GtkAttachOptions) (0),
		    (GtkAttachOptions) (0), 0, 0);

	lblType = gtk_label_new (_("Type"));
	gtk_widget_show (lblType);
	gtk_table_attach (GTK_TABLE (table1), lblType, 1, 2, 0, 1,
		    (GtkAttachOptions) (0),
		    (GtkAttachOptions) (0), 0, 0);

	lblURI = gtk_label_new (_("URI"));
	gtk_widget_show (lblURI);
	gtk_table_attach (GTK_TABLE (table1), lblURI, 2, 3, 0, 1,
		    (GtkAttachOptions) (0),
		    (GtkAttachOptions) (0), 0, 0);

	entryURI = gtk_entry_new ();
	gtk_widget_show (entryURI);
	gtk_table_attach (GTK_TABLE (table1), entryURI, 2, 3, 1, 2,
		    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
		    (GtkAttachOptions) (0), 0, 0);

	optType = gtk_option_menu_new();
	optTypeMenu = gtk_menu_new();
	
	itemfact = gtk_item_factory_new (GTK_TYPE_MENU, "<main>", NULL);
	gtk_item_factory_create_items (itemfact, sizeof (items) / sizeof (items[0]), items, NULL);
/*old	item = gtk_menu_item_new_with_label("deb");
	gtk_menu_append(GTK_MENU(optTypeMenu), item);
	gtk_widget_show(item);
	gtk_object_set_data(GTK_OBJECT(item), "id", (gpointer)ITEM_TYPE_DEB);
	item = gtk_menu_item_new_with_label("deb-src");
	gtk_menu_append(GTK_MENU(optTypeMenu), item);
	gtk_widget_show(item);
	gtk_object_set_data(GTK_OBJECT(item), "id", (gpointer)ITEM_TYPE_DEBSRC);
*/
	optTypeMenu = gtk_item_factory_get_widget (itemfact, "<main>");
	item = gtk_item_factory_get_widget_by_action (itemfact, ITEM_TYPE_DEB);
	g_object_set_data(G_OBJECT(item), "id", (gpointer)ITEM_TYPE_DEB);
	item = gtk_item_factory_get_widget_by_action (itemfact, ITEM_TYPE_DEBSRC);
	g_object_set_data(G_OBJECT(item), "id", (gpointer)ITEM_TYPE_DEBSRC);
	
	gtk_option_menu_set_menu(GTK_OPTION_MENU(optType), optTypeMenu);

	gtk_table_attach (GTK_TABLE (table1), optType, 1, 2, 1, 2,
		    (GtkAttachOptions) (GTK_FILL),
		    (GtkAttachOptions) (0), 0, 0);

	cbDisabled = gtk_check_button_new_with_label (_("Disabled"));
	gtk_widget_show (cbDisabled);
	gtk_table_attach (GTK_TABLE (table1), cbDisabled, 0, 1, 1, 2,
		    (GtkAttachOptions) (0),
		    (GtkAttachOptions) (0), 0, 0);

	table2 = gtk_table_new (2, 2, FALSE);
	gtk_widget_show (table2);
	gtk_box_pack_end (GTK_BOX (vbox1), table2, FALSE, FALSE, 5);
	gtk_table_set_col_spacings (GTK_TABLE (table2), 10);

	lblDist = gtk_label_new (_("Distribution"));
	gtk_widget_show (lblDist);
	gtk_table_attach (GTK_TABLE (table2), lblDist, 0, 1, 0, 1,
		    (GtkAttachOptions) (0),
		    (GtkAttachOptions) (0), 0, 0);

	lblSection = gtk_label_new (_("Section"));
	gtk_widget_show (lblSection);
	gtk_table_attach (GTK_TABLE (table2), lblSection, 1, 2, 0, 1,
		    (GtkAttachOptions) (0),
		    (GtkAttachOptions) (0), 0, 0);

	hbox3 = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox3);
	gtk_table_attach (GTK_TABLE (table2), hbox3, 1, 2, 1, 2,
		    (GtkAttachOptions) (0),
		    (GtkAttachOptions) (0), 0, 0);
	gtk_container_set_border_width (GTK_CONTAINER (hbox3), 5);

	cbMain = gtk_check_button_new_with_label (_("Main"));
	gtk_widget_show (cbMain);
	gtk_box_pack_start (GTK_BOX (hbox3), cbMain, FALSE, FALSE, 0);

	cbContrib = gtk_check_button_new_with_label (_("Contrib"));
	gtk_widget_show (cbContrib);
	gtk_box_pack_start (GTK_BOX (hbox3), cbContrib, FALSE, FALSE, 0);

	cbNonFree = gtk_check_button_new_with_label (_("Non-Free"));
	gtk_widget_show (cbNonFree);
	gtk_box_pack_start (GTK_BOX (hbox3), cbNonFree, FALSE, FALSE, 0);

	cbNonUS = gtk_check_button_new_with_label (_("Non-US"));
	gtk_widget_show (cbNonUS);
	gtk_box_pack_start (GTK_BOX (hbox3), cbNonUS, FALSE, FALSE, 0);

	lblSectother = gtk_label_new (_("Other:"));
	gtk_widget_show (lblSectother);
	gtk_box_pack_start (GTK_BOX (hbox3), lblSectother, FALSE, FALSE, 0);
	gtk_label_set_justify (GTK_LABEL (lblSectother), GTK_JUSTIFY_RIGHT);
	gtk_misc_set_padding (GTK_MISC (lblSectother), 10, 0);

	entrySect = gtk_entry_new ();
	gtk_widget_show (entrySect);
	gtk_box_pack_end (GTK_BOX (hbox3), entrySect, TRUE, TRUE, 0);

	comDist = gtk_combo_new ();
	gtk_widget_show (comDist);
	gtk_table_attach (GTK_TABLE (table2), comDist, 0, 1, 1, 2,
		    (GtkAttachOptions) (GTK_EXPAND),
		    (GtkAttachOptions) (0), 0, 0);
	comDist_items = g_list_append (comDist_items, (gpointer)_("stable"));
	comDist_items = g_list_append (comDist_items, (gpointer)_("frozen"));
	comDist_items = g_list_append (comDist_items, (gpointer)_("unstable"));
	comDist_items = g_list_append (comDist_items, (gpointer)_("testing"));
	gtk_combo_set_popdown_strings (GTK_COMBO (comDist), comDist_items);
	g_list_free (comDist_items);

	comDistEntry = GTK_COMBO (comDist)->entry;
	gtk_widget_show (comDistEntry);
	gtk_entry_set_text (GTK_ENTRY (comDistEntry), _("stable"));

	dialog_action_area1 = GTK_DIALOG (dlgSrcList)->action_area;
	gtk_widget_show (dialog_action_area1);
	gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area1), 10);

	hbox1 = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox1);
	gtk_box_pack_start (GTK_BOX (dialog_action_area1), hbox1, TRUE, TRUE, 8);

	btnOK = gtk_button_new_with_label (_("OK"));
	gtk_widget_show (btnOK);
	gtk_box_pack_start (GTK_BOX (hbox1), btnOK, TRUE, TRUE, 10);

	btnCancel = gtk_button_new_with_label (_("Cancel"));
	gtk_widget_show (btnCancel);
	gtk_box_pack_end (GTK_BOX (hbox1), btnCancel, TRUE, TRUE, 10);


/*old	gtk_signal_connect(GTK_OBJECT(lstSources), "select-row",
		GTK_SIGNAL_FUNC(UpdateDisplay), (gpointer)this);
*/	g_signal_connect(G_OBJECT(select), "changed",
			 G_CALLBACK(UpdateDisplay), (gpointer)this);
/*old	gtk_signal_connect(GTK_OBJECT(lstSources), "unselect-row",
		GTK_SIGNAL_FUNC(UnselectRow), (gpointer)this);
*/
	if (isRoot) {
/*old		gtk_signal_connect(GTK_OBJECT(btnAddNew), "clicked",
			GTK_SIGNAL_FUNC(DoAdd), (gpointer)this);
*/		g_signal_connect(G_OBJECT(btnAddNew), "clicked",
				 G_CALLBACK(DoAdd), (gpointer)this);
/*old		gtk_signal_connect(GTK_OBJECT(btnEdit), "clicked",
			GTK_SIGNAL_FUNC(DoEdit), (gpointer)this);
*/		g_signal_connect(G_OBJECT(btnEdit), "clicked",
				 G_CALLBACK(DoEdit), (gpointer)this);
/*old		gtk_signal_connect(GTK_OBJECT(btnRemove), "clicked",
			GTK_SIGNAL_FUNC(DoRemove), (gpointer)this);
*/		g_signal_connect(G_OBJECT(btnRemove), "clicked",
				 G_CALLBACK(DoRemove), (gpointer)this);
	} else {
		gtk_widget_set_sensitive(btnAddNew, FALSE);
		gtk_widget_set_sensitive(btnEdit, FALSE);
		gtk_widget_set_sensitive(btnRemove, FALSE);
	}

/*old	gtk_signal_connect(GTK_OBJECT(btnOK), "clicked",
		GTK_SIGNAL_FUNC(DoOK), (gpointer)this);
*/	g_signal_connect(G_OBJECT(btnOK), "clicked",
			 G_CALLBACK(DoOK), (gpointer)this);
/*old	gtk_signal_connect(GTK_OBJECT(btnCancel), "clicked",
		GTK_SIGNAL_FUNC(DoCancel), (gpointer)this);
*/	g_signal_connect(G_OBJECT(btnCancel), "clicked",
			 G_CALLBACK(DoCancel), (gpointer)this);

	return dlgSrcList;
}

void GtkUI::SrcEditor::Run()
{
	GtkTreeIter iter;

	if (lst.ReadSources() == false) {
		CaptUI->ShowDialog(_("Error"), _("Cannot read sources.lst file"));
		return;
	}

	GdkColormap *cmap = gdk_colormap_get_system();
	GdkColor gray;
	gray.red = gray.green = gray.blue = 0xAA00;
//old	gdk_color_alloc(cmap, &gray);
	gdk_colormap_alloc_color(cmap, &gray, TRUE, FALSE);		
	
	SourcesList::SourceRecord *rec = lst.Head();

//old	gtk_clist_freeze(GTK_CLIST(lstSources));
	gtk_widget_freeze_child_notify (lstSources);
//old	gtk_clist_clear(GTK_CLIST(lstSources));
	gtk_list_store_clear (lstSourcesstore);

	for (; rec != NULL; rec = rec->next) {
		if (rec->Type & SourcesList::Comment) continue;
		string Sections;
		for (unsigned int J = 0; J < rec->NumSections; J++) {
			Sections += rec->Sections[J];
			Sections += " ";
		}

//old		const gchar *rowtxt[] = {
//			((rec->Type & SourcesList::Disabled) ? "Disabled" : "Enabled"),
//			((rec->Type & SourcesList::Deb) ? "deb" : "deb-src"),
//			rec->URI.c_str(), rec->Dist.c_str(), Sections.c_str()
//		};
//old		gint row = gtk_clist_append(GTK_CLIST(lstSources), (gchar **)rowtxt);
		gtk_list_store_append (lstSourcesstore, &iter);
//old		gtk_clist_set_row_data(GTK_CLIST(lstSources), row, (gpointer)rec);
		gtk_list_store_set (lstSourcesstore, &iter,
				    Active_Col,		((rec->Type & SourcesList::Disabled) ? _("Disabled") : _("Enabled")),
				    DebType_Col,	((rec->Type & SourcesList::Deb) ? _("deb") : _("deb-src")),
				    URI_Col,		rec->URI.c_str(),
				    Distrib_Col,	rec->Dist.c_str(),
				    Section_Col,	Sections.c_str(),
				    Color_Col,		(rec->Type & SourcesList::Disabled ? "gray" : "white"),
				    SrcRec_Col,		rec,
				    -1);
				    
//old		if (rec->Type & SourcesList::Disabled) 
//			gtk_clist_set_foreground(GTK_CLIST(lstSources), row, &gray);
	}

//old	gtk_clist_thaw(GTK_CLIST(lstSources));
	gtk_widget_thaw_child_notify (lstSources);
	
	gtk_widget_show_all(dialog);
	gtk_main();
}

void GtkUI::SrcEditor::DoAdd(GtkWidget *, gpointer data)
{
	GtkUI::SrcEditor *This = (GtkUI::SrcEditor *)data;
	unsigned char Type = 0;
	const char *Section;
	string URI;
	string Dist;
	string Sections[5];
	unsigned short count = 0;

	GtkTreeIter iter;

	if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(This->cbDisabled)))
		Type |= SourcesList::Disabled;

	GtkWidget *menuitem = gtk_menu_get_active(GTK_MENU(This->optTypeMenu));
	switch ((int)g_object_get_data(G_OBJECT(menuitem), "id")/*gtk_object_get_data(GTK_OBJECT(menuitem), "id")*/) {
		case ITEM_TYPE_DEB:
			Type |= SourcesList::Deb; break;
		case ITEM_TYPE_DEBSRC:
			Type |= SourcesList::DebSrc; break;
		default:
			CaptUI->ShowDialog(_("Error"), _("Unknown source type"));
			return;
	}

	URI = gtk_entry_get_text(GTK_ENTRY(This->entryURI));
	Dist = gtk_entry_get_text(GTK_ENTRY(This->comDistEntry));

	if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(This->cbMain)))
		Sections[count++] = _("main");
	if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(This->cbContrib)))
		Sections[count++] = _("contrib");
	if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(This->cbNonFree)))
		Sections[count++] = _("non-free");
	if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(This->cbNonUS)))
		Sections[count++] = _("non-US");
	Section = gtk_entry_get_text(GTK_ENTRY(This->entrySect));

	if (Section != 0 && Section[0] != 0)
		Sections[count++] = Section;

	SourcesList::SourceRecord *rec = This->lst.AddSource((SourcesList::RecType)Type, URI, Dist, Sections, count);

	string Sects;
	for (unsigned short J = 0; J < rec->NumSections; J++) {
		Sects += rec->Sections[J];
		Sects += " ";
	}

//old	const gchar *rowtxt[] = {
//		((rec->Type & SourcesList::Disabled) ? "Disabled" : "Enabled"),
//		((rec->Type & SourcesList::Deb) ? "deb" : "deb-src"),
//		rec->URI.c_str(), rec->Dist.c_str(), Sects.c_str()
//	};
//old	gint row = gtk_clist_append(GTK_CLIST(This->lstSources), (gchar **)rowtxt);
	gtk_list_store_append (This->lstSourcesstore, &iter);
//old	gtk_clist_set_row_data(GTK_CLIST(This->lstSources), row, (gpointer)rec);
	gtk_list_store_set (This->lstSourcesstore, &iter,
			    Active_Col,		((rec->Type & SourcesList::Disabled) ? _("Disabled") : _("Enabled")),
			    DebType_Col,	((rec->Type & SourcesList::Deb) ? _("deb") : _("deb-src")),
			    URI_Col,		rec->URI.c_str(),
			    Distrib_Col,	rec->Dist.c_str(),
			    Section_Col,	Sects.c_str(),
			    Color_Col, 		(rec->Type & SourcesList::Disabled ? "gray" : "white"),
			    SrcRec_Col,		rec,
			    -1);
}			    

void GtkUI::SrcEditor::DoEdit(GtkWidget *, gpointer data)
{
	GtkTreeIter iter;
	GtkTreeModel *model;
	GtkTreeSelection *select;
	
	GtkUI::SrcEditor *This = (GtkUI::SrcEditor *)data;

//old	if (This->selectedrow < 0) return; /* no row selected */
	select = gtk_tree_view_get_selection (GTK_TREE_VIEW(This->lstSources));
	if (!gtk_tree_selection_get_selected (select, &model, &iter)) return;

	SourcesList::SourceRecord *rec;//old = *((SourcesList::SourceRecord *)gtk_clist_get_row_data(GTK_CLIST(This->lstSources), This->selectedrow));
	gtk_tree_model_get (model, &iter, SrcRec_Col, &rec, -1);
	
	rec->Type = 0;
	if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(This->cbDisabled)))
		rec->Type |= SourcesList::Disabled;
		
	GtkWidget *menuitem = gtk_menu_get_active(GTK_MENU(This->optTypeMenu));
	switch ((long)g_object_get_data(G_OBJECT(menuitem), "id")/*gtk_object_get_data(GTK_OBJECT(menuitem), "id")*/) {
		case ITEM_TYPE_DEB:
			rec->Type |= SourcesList::Deb; break;
		case ITEM_TYPE_DEBSRC:
			rec->Type |= SourcesList::DebSrc; break;
		default:
			CaptUI->ShowDialog(_("Error"), _("Unknown source type"));
			return;
	}

	rec->URI = gtk_entry_get_text(GTK_ENTRY(This->entryURI));
	rec->Dist = gtk_entry_get_text(GTK_ENTRY(This->comDistEntry));
	
	delete[] rec->Sections;
	rec->NumSections = 0;

	if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(This->cbMain)))
		rec->NumSections++;
	if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(This->cbContrib)))
		rec->NumSections++;
	if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(This->cbNonFree)))
		rec->NumSections++;
	if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(This->cbNonUS)))
		rec->NumSections++;
		
//old	char *Section = gtk_entry_get_text(GTK_ENTRY(This->entrySect));
	char *Section = (char *) gtk_entry_get_text(GTK_ENTRY(This->entrySect));
	if (Section != 0 && Section[0] != 0)
		rec->NumSections++;

	rec->Sections = new string[rec->NumSections];
	rec->NumSections = 0;
	if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(This->cbMain)))
		rec->Sections[rec->NumSections++] = _("main");
	if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(This->cbContrib)))
		rec->Sections[rec->NumSections++] = _("contrib");
	if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(This->cbNonFree)))
		rec->Sections[rec->NumSections++] = _("non-free");
	if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(This->cbNonUS)))
		rec->Sections[rec->NumSections++] = _("non-US");
//old	Section = gtk_entry_get_text(GTK_ENTRY(This->entrySect));
	Section = (char *) gtk_entry_get_text(GTK_ENTRY(This->entrySect));

	if (Section != 0 && Section[0] != 0)
		rec->Sections[rec->NumSections++] = Section;

	string Sect;
	for (unsigned int I = 0; I < rec->NumSections; I++) {
		Sect += rec->Sections[I];
		Sect += " ";
	}

	/* repaint screen */
/*old	gtk_clist_set_text(GTK_CLIST(This->lstSources), This->selectedrow,
		0, (rec.Type & SourcesList::Disabled ? "Disabled" : "Enabled"));
	gtk_clist_set_text(GTK_CLIST(This->lstSources), This->selectedrow,
		1, (rec.Type & SourcesList::Deb ? "deb" : (rec.Type & SourcesList::DebSrc ? "deb-src" : "")));
	gtk_clist_set_text(GTK_CLIST(This->lstSources), This->selectedrow,
		2, rec.URI.c_str());
	gtk_clist_set_text(GTK_CLIST(This->lstSources), This->selectedrow,
		3, rec.Dist.c_str());
	gtk_clist_set_text(GTK_CLIST(This->lstSources), This->selectedrow,
		4, Sect.c_str());
*/
	gtk_list_store_set (This->lstSourcesstore, &iter,
			    Active_Col,		(rec->Type & SourcesList::Disabled ? _("Disabled") : _("Enabled")),
			    DebType_Col,	(rec->Type & SourcesList::Deb ? _("deb") : (rec->Type & SourcesList::DebSrc ? _("deb-src") : "")),
			    URI_Col,		rec->URI.c_str(),
			    Distrib_Col,	rec->Dist.c_str(),
			    Section_Col,	Sect.c_str(),
			    Color_Col,		(rec->Type & SourcesList::Disabled ? "gray" : "white"),
			    -1);

/*	if (rec.Type & SourcesList::Disabled) {
		GdkColormap *cmap = gdk_colormap_get_system();
		GdkColor gray;
		gray.red = gray.green = gray.blue = 0xAA00;
//old		gdk_color_alloc(cmap, &gray);
		gdk_colormap_alloc_color(cmap, &gray, TRUE, FALSE);		
//old		gtk_clist_set_foreground(GTK_CLIST(This->lstSources),
//			This->selectedrow, &gray);
	} else {
//old		gtk_clist_set_foreground(GTK_CLIST(This->lstSources),
//			This->selectedrow, NULL);
	}
*/
}

void GtkUI::SrcEditor::DoRemove(GtkWidget *, gpointer data)
{
	GtkTreeSelection *select;
	GtkTreeModel *model;
	GtkTreeIter iter;
	
	GtkUI::SrcEditor *This = (GtkUI::SrcEditor *)data;
//old	gint row = This->selectedrow;
//old	if (row < 0) return;

	select = gtk_tree_view_get_selection (GTK_TREE_VIEW(This->lstSources));
	if (!gtk_tree_selection_get_selected (select, &model, &iter)) return;

	SourcesList::SourceRecord *rec = NULL;//old = (SourcesList::SourceRecord *)gtk_clist_get_row_data(GTK_CLIST(This->lstSources), row);
	gtk_tree_model_get (model, &iter, SrcRec_Col, &rec, -1);

	This->lst.RemoveSource(rec);
//old	gtk_clist_remove(GTK_CLIST(This->lstSources), row);
	gtk_list_store_remove (This->lstSourcesstore, &iter);
}

void GtkUI::SrcEditor::DoOK(GtkWidget *, gpointer data)
{
	GtkUI::SrcEditor *This = (GtkUI::SrcEditor *)data;
	if (This->isRoot) This->lst.UpdateSources();
	gtk_main_quit();
}

void GtkUI::SrcEditor::DoCancel(GtkWidget *, gpointer data)
{
	//GtkUI::SrcEditor *This = (GtkUI::SrcEditor *)data;
	gtk_main_quit();
}
/*old
void GtkUI::SrcEditor::UnselectRow(GtkCList *clist, gint row, gint col,
	GdkEventButton *event, gpointer data)
{
	GtkUI::SrcEditor *This = (GtkUI::SrcEditor *)data;

	This->selectedrow = -1;
}
*/
/*old
void GtkUI::SrcEditor::UpdateDisplay(GtkCList *clist, gint row, gint col,
	GdkEventButton *event, gpointer data)*/
void GtkUI::SrcEditor::UpdateDisplay(GtkTreeSelection *select, gpointer data)
{
	gchar *rowtxt[5];
	gchar *sections;
	int sectionlen = 0;

	GtkTreeIter iter;
        GtkTreeModel *model;

	GtkUI::SrcEditor *This = (GtkUI::SrcEditor *)data;
//old	This->selectedrow = row;
	
	if (!gtk_tree_selection_get_selected (select, &model, &iter)) return;
	gtk_tree_model_get (model, &iter,
			    Active_Col,		&rowtxt[0],
			    DebType_Col,	&rowtxt[1],
			    URI_Col,		&rowtxt[2],
			    Distrib_Col,	&rowtxt[3],
			    Section_Col,	&rowtxt[4],
			    -1);

//old	const SourcesList::SourceRecord &rec = *((SourcesList::SourceRecord *)gtk_clist_get_row_data(clist, row));

//old	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(This->cbDisabled), (rec.Type & SourcesList::Disabled));
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(This->cbDisabled), rowtxt[0][0] != 'E');
//old	gtk_option_menu_set_history(GTK_OPTION_MENU(This->optType), (rec.Type & SourcesList::DebSrc ? ITEM_TYPE_DEBSRC : ITEM_TYPE_DEB));
	gtk_option_menu_set_history(GTK_OPTION_MENU(This->optType), (strlen (rowtxt[1]) != 3 ? ITEM_TYPE_DEBSRC : ITEM_TYPE_DEB));
//old	gtk_entry_set_text(GTK_ENTRY(This->entryURI), rec.URI.c_str());
	gtk_entry_set_text(GTK_ENTRY(This->entryURI), rowtxt[2]);
//old	gtk_entry_set_text(GTK_ENTRY(This->comDistEntry), rec.Dist.c_str());
	gtk_entry_set_text(GTK_ENTRY(This->comDistEntry), rowtxt[3]);

	// reset all the section fields first...
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(This->cbMain), FALSE);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(This->cbContrib), FALSE);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(This->cbNonFree), FALSE);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(This->cbNonUS), FALSE);
	gtk_entry_set_text(GTK_ENTRY(This->entrySect), "");

//old	for (unsigned int I = 0; I < rec.NumSections; I++) {
	sections = strtok (rowtxt[4], " ");
	while (sections != NULL) 
	{
/*old	    if (rec.Sections[I] == "main")
	    	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(This->cbMain), TRUE);
	    else if (rec.Sections[I] == "contrib")
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(This->cbContrib), TRUE);
	    else if (rec.Sections[I] == "non-free")
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(This->cbNonFree), TRUE);
	    else if (rec.Sections[I] == "non-US")
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(This->cbNonUS), TRUE);
	    else 
	    {
		gtk_entry_append_text(GTK_ENTRY(This->entrySect), rec.Sections[I].c_str());
		gtk_entry_append_text(GTK_ENTRY(This->entrySect), " ");
	    }
*/
	    if (strcmp (sections, _("main")) == 0)
	    	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(This->cbMain), TRUE);
	    else if (strcmp (sections, _("contrib")) == 0)
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(This->cbContrib), TRUE);
	    else if (strcmp (sections, _("non-free")) == 0)
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(This->cbNonFree), TRUE);
	    else if (strcmp (sections, _("non-US")) == 0)
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(This->cbNonUS), TRUE);
	    else 
	    {
//old		gtk_entry_append_text(GTK_ENTRY(This->entrySect), sections);
		gtk_entry_set_text(GTK_ENTRY(This->entrySect), &sections[sectionlen]);
		return;
//old		gtk_entry_append_text(GTK_ENTRY(This->entrySect), " ");
	    }
	    
	    ++ sectionlen +=  strlen (sections);
	    sections = strtok (NULL, " ");
	}
}
