/* $Id: util.cc,v 1.3 2000/11/17 14:56:21 ltd Exp $ */
#include "util.h"

#include <gtk/gtk.h>


//old GdkPixmap *GtkUtil::PixmapFromXPM(char **xpm_data, GdkColor *trans_color = NULL)
GdkPixmap *GtkUtil::PixmapFromXPM(char **xpm_data, GdkColor *trans_color)
{
	GdkBitmap *mask = NULL;
	GdkColormap *cmap = gdk_colormap_get_system();

	return gdk_pixmap_colormap_create_from_xpm_d(NULL, cmap, &mask, trans_color, (gchar **)xpm_data); 
}

//old GtkWidget *GtkUtil::ImageFromXPM(char **xpm_data, GdkColor *trans_color = NULL)
GtkWidget *GtkUtil::ImageFromXPM(char **xpm_data, GdkColor *trans_color)
{
	GdkPixmap *pixmap = NULL;
	GdkBitmap *mask = NULL;
	GdkColormap *cmap = gdk_colormap_get_system();

	pixmap = gdk_pixmap_colormap_create_from_xpm_d(NULL, cmap, &mask, trans_color, (gchar **)xpm_data); 

	if (pixmap == NULL) return NULL;
	return gtk_image_new_from_pixmap(pixmap, mask);
}

//old GdkPixmap *GtkUtil::PixmapFromXPMFile(const char *fn, GdkColor *trans_color = NULL)
GdkPixmap *GtkUtil::PixmapFromXPMFile(const char *fn, GdkColor *trans_color)
{
	GdkBitmap *mask = NULL;
	GdkColormap *cmap = gdk_colormap_get_system();

	return gdk_pixmap_colormap_create_from_xpm(NULL, cmap, &mask, trans_color, fn);
}

//old GtkWidget *GtkUtil::ImageFromXPMFile(const char *fn, GdkColor *trans_color = NULL)
GtkWidget *GtkUtil::ImageFromXPMFile(const char *fn, GdkColor *trans_color)
{
	GdkPixmap *pixmap = NULL;
	GdkBitmap *mask = NULL;
	GdkColormap *cmap = gdk_colormap_get_system();

	pixmap = gdk_pixmap_colormap_create_from_xpm(NULL, cmap, &mask, trans_color, fn);

	if (pixmap == NULL) return NULL;
	return gtk_image_new_from_pixmap(pixmap, mask);
}
