/* $Id: apt.h,v 1.9 2001/05/14 15:07:02 ltd Exp $ */
#ifndef _apt_H
#define _apt_H

#include <apt-pkg/cachefile.h>

#include "statecache.h"

class edeitypkgcache : public pkgCacheFile
{
protected:
	pkgProblemResolver *Fix;
	pkgRecords *Recs;

	CaptStateCache State;

public:
	inline operator pkgCache & () { return *Cache; }
	inline pkgCache *GetCache() { return Cache; }

	inline pkgProblemResolver & Resolver() { return *Fix; };
	inline pkgRecords & GetPkgRecs() { return *Recs; };

	void Destruct();
	void Construct();
	void Reinit();

	edeitypkgcache();
	~edeitypkgcache();
};

extern edeitypkgcache *Cache;

#endif /* _apt_H */
