/* $Id: acquireui.h,v 1.7 2001/05/23 22:41:12 ltd Exp $ */
#ifndef _interface_acquireui_H
#define _interface_acquireui_H

#include <interface/edeityui.h>
#include <func/messages.h>
#include <vector>

class EDeityUI::AcquireUI
{
public:
	enum { UpdateRun, PackageRun } acqState;	
	
	virtual void Startup() = 0;
	virtual void Shutdown() = 0;
	virtual void Refresh() {};

	virtual void Message(const char *text) {};

	virtual void DispatchKey(int key) = 0;

	virtual void Start() = 0;
	virtual void Stop() = 0;
	virtual void IMSHit(const MsgItemDesc *M) = 0;
	virtual void Fetch(const MsgItemDesc *M) = 0;
	virtual void Done(const MsgItemDesc *M) = 0;
	virtual void Fail(const MsgItemFailed *M) = 0;
	virtual void MediaChange(const MsgMediaChange *M) = 0;

	virtual bool ReadyToInstall() { return true; }

	virtual void Update(const vector<MsgDownloadItem> *ItemList, const MsgDownloadTotal *Total) = 0;

public:
	AcquireUI() {};
	virtual ~AcquireUI() {};
};

#endif
