/* $Id: about.cc,v 1.3 2000/11/17 14:56:21 ltd Exp $ */
//old #include <std.h>
#include "pixmaps/swirl.xpm"
#include "about.h"

GtkUI::About::About()
{
	GtkWidget *button;
	GtkWidget *label;
	GtkWidget *swirl;
	GdkPixmap *pixmap;
	GtkStyle  *style;
	GdkBitmap *mask;

	window = gtk_dialog_new();
	gtk_window_set_title(GTK_WINDOW(window), _("About EDeity"));
	gtk_window_set_default_size(GTK_WINDOW(window), 300, 200);
	gtk_window_set_modal(GTK_WINDOW(window), TRUE);

	/* Program title */
	label = gtk_label_new(PACKAGE " " VERSION "\n");
	gtk_container_add(GTK_CONTAINER(GTK_DIALOG(window)->vbox), label);

	/* The icon */
	GdkColormap *cmap = gdk_colormap_get_system();
	
	GdkColor white;
	white.red = 0xffff;
	white.green = 0xffff;
	white.blue = 0xffff;

//old	if (!gdk_color_alloc(cmap, &white))
	if (!gdk_colormap_alloc_color(cmap, &white, TRUE, FALSE))
		g_error(_("couldn't allocate color"));

	style = gtk_widget_get_style(window);	
	pixmap = gdk_pixmap_colormap_create_from_xpm_d(window->window, cmap, &mask,
		&white, (gchar **)swirl_xpm);
	swirl = gtk_pixmap_new(pixmap, mask);
	gtk_container_add(GTK_CONTAINER(GTK_DIALOG(window)->vbox), swirl);

        // maybe we can use this quote instead.....
	// <ltd> Maybe we can sell advertising space under the flashes	
	label = gtk_label_new(_("\n\n" \
		"\"There is no Main Window [tm]\"\n\n" \
		"Patrick Cole <z@amused.net> and\n" \
		"Randolph Chung <tausq@debian.org>\n" \
		"Holczer Szilard <szilard@uhulinux.hu>"));
	gtk_container_add(GTK_CONTAINER(GTK_DIALOG(window)->vbox), label);
		
	button = gtk_button_new_with_label(_("Ok"));
/*old	gtk_signal_connect(GTK_OBJECT(button), "clicked",
		GTK_SIGNAL_FUNC(Done), (gpointer)this);
*/	g_signal_connect(G_OBJECT(button), "clicked",
			G_CALLBACK(Done), (gpointer)this);


	gtk_container_add(GTK_CONTAINER(GTK_DIALOG(window)->action_area),
		button);
	
	gtk_widget_show_all(window);
	gtk_main();
}

GtkUI::About::~About()
{
	gtk_widget_destroy(window);
}

void GtkUI::About::Done(GtkButton *, gpointer p)
{
	gtk_main_quit();
}
