/* $Id: filteredit.cc,v 1.2 2001/03/24 08:08:32 ltd Exp $ */
//old #include <std.h>

#include "screen.h"
#include "filteredit.h"
//old #include <func/config.h>

//old static gchar *filterlabels[] = {
//old 	_("Name"),
//old 	_("Available version"),
//old 	_("Installed version"),
//old 	_("Section"),
//old 	_("Priority"),
//old 	_("Short description"),
//old 	_("Long description")
//old };

//GtkUI::FilterEditor::FilterEditor(GtkUI &_ui)
//	: ui(_ui)
GtkUI::FilterEditor::FilterEditor(GtkUI::Screen &_screen)
	: screen(_screen)
{
//old	filters = Filter::Target(Filter::pkgname |
//		  		 Filter::pkgavailver |
//		 		 Filter::pkginstlver |
//		 		 Filter::pkgsection |
//				 Filter::pkgpriority |
//				 Filter::pkgshortdesc |
//				 Filter::pkglongdesc);
//old	baserow = -1;
//old	targetrow = -1;

//old	for (int k = 0; k < NUM_FILTER_TYPES; k++)
//	{
//		baseselected[k] = true;
//		targetselected[k] = false;
//	}

	dialog = CreateWidget();
}

GtkUI::FilterEditor::~FilterEditor()
{
	gtk_widget_destroy(dialog);
}

GtkWidget *GtkUI::FilterEditor::CreateWidget()
{

	GtkItemFactoryEntry txtpkgoptmnulbls[] = {
	    { _("/choose category"),	NULL,	GtkItemFactoryCallback (MenuChange),	0x120,	"<Item>" },
	    { _("/package name"),		NULL,	GtkItemFactoryCallback (MenuChange),	0x120,	"<Item>" },
	    { _("/candidate version"),	NULL,	GtkItemFactoryCallback (MenuChange),	0x120,	"<Item>" },
	    { _("/install version"),	NULL,	GtkItemFactoryCallback (MenuChange),	0x120,	"<Item>" },
	    { _("/maintainer"),			NULL,	GtkItemFactoryCallback (MenuChange),	0x120,	"<Item>" },
	    { _("/file name"),			NULL,	GtkItemFactoryCallback (MenuChange),	0x120,	"<Item>" },
	    { _("/short description"),	NULL,	GtkItemFactoryCallback (MenuChange),	0x120,	"<Item>" },
	    { _("/long description"),	NULL,	GtkItemFactoryCallback (MenuChange),	0x120,	"<Item>" }
	};
	guint ntxtpkgoptmnulbls = sizeof(txtpkgoptmnulbls) / sizeof(txtpkgoptmnulbls[0]);

	GtkItemFactoryEntry catpkgoptmnulbls[] = {
	    { _("/choose category"),	NULL,	GtkItemFactoryCallback (MenuChange),	0x020,	"<Item>" },
	    { _("/status"),				NULL,	GtkItemFactoryCallback (MenuChange),	0x020,	"<Item>" },
	    { _("/specified status"),	NULL,	GtkItemFactoryCallback (MenuChange),	0x020,	"<Item>" },
	    { _("/section"),			NULL,	GtkItemFactoryCallback (MenuChange),	0x020,	"<Item>" },
	    { _("/priority"),			NULL,	GtkItemFactoryCallback (MenuChange),	0x020,	"<Item>" },
//	    { _("/suite"),				NULL,	GtkItemFactoryCallback (MenuChange),	0x020,	"<Item>" },
	    { _("/has depend"),			NULL,	GtkItemFactoryCallback (MenuChange),	0x020,	"<Item>" },
	    { _("/has rev. depend"),	NULL,	GtkItemFactoryCallback (MenuChange),	0x020,	"<Item>" }
	};
	guint ncatpkgoptmnulbls = sizeof(catpkgoptmnulbls) / sizeof(catpkgoptmnulbls[0]);

	GtkItemFactoryEntry txtopoptmnulbls[] = {
	    { _("/choose category"),	NULL,	GtkItemFactoryCallback (MenuChange),	0x130,	"<Item>" },
	    { _("/is equal to"),		NULL,	GtkItemFactoryCallback (MenuChange),	0x130,	"<Item>" },
	    { _("/is not equal to"),	NULL,	GtkItemFactoryCallback (MenuChange),	0x130,	"<Item>" },
	    { _("/is less than"),		NULL,	GtkItemFactoryCallback (MenuChange),	0x130,	"<Item>" },
	    { _("/is graeter than"),	NULL,	GtkItemFactoryCallback (MenuChange),	0x130,	"<Item>" },
	    { _("/contains"),			NULL,	GtkItemFactoryCallback (MenuChange),	0x130,	"<Item>" },
	    { _("/does not contain"),	NULL,	GtkItemFactoryCallback (MenuChange),	0x130,	"<Item>" }
	};
	guint ntxtopoptmnulbls = sizeof(txtopoptmnulbls) / sizeof(txtopoptmnulbls[0]);

	GtkItemFactoryEntry catopoptmnulbls[] = {
	    { _("/Choose category"),	NULL,	GtkItemFactoryCallback (MenuChange),	0x030,	"<Item>" }
	};
	guint ncatopoptmnulbls = sizeof(catopoptmnulbls) / sizeof(catopoptmnulbls[0]);

	gchar objectkey[nKey + 1] = "";
	
	GtkWidget *optmenu;
	GtkWidget *optmenu_mnu;
	GtkWidget *advpage;
	GtkWidget *chkbtn;
	GtkItemFactory *itemfact;

	dialog = gtk_dialog_new();
	gtk_window_set_title(GTK_WINDOW(dialog), _("Add new filter"));
	gtk_window_set_modal(GTK_WINDOW(dialog), TRUE);
	gtk_window_set_policy(GTK_WINDOW(dialog), TRUE, TRUE, FALSE);

	GtkWidget *dlgvbox = GTK_DIALOG(dialog)->vbox;
	
	GtkWidget *notebook = gtk_notebook_new();
	
	g_object_set_data(G_OBJECT(dialog), "notebook", gpointer(notebook));
	
	gtk_box_pack_start(GTK_BOX(dlgvbox), notebook, FALSE, TRUE, 0);

	// First page -- simple search
	objectkey[Notebook] = '0';
	
	advpage = gtk_table_new(6, 5, FALSE);
	
	gtk_container_add(GTK_CONTAINER(notebook), advpage);

	gtk_notebook_set_tab_label(GTK_NOTEBOOK(notebook), 
		gtk_notebook_get_nth_page(GTK_NOTEBOOK(notebook), 0),
		gtk_label_new(_("Category filter")));

	
	// create the field option menus
	for (int i = 0; i < 6; i++) {
		objectkey[Row] = i + '0';
		objectkey[Column] = '0';
		
		if (i != 0) {
			for (int j = 0; j < ncatpkgoptmnulbls; j++) catpkgoptmnulbls[j].callback_action++; 
			for (int j = 0; j < ncatopoptmnulbls; j++)	catopoptmnulbls[j].callback_action++; 
			
			GSList *radiogrp = NULL;
			GtkWidget *radioand = gtk_radio_button_new_with_label(NULL, _("and"));
			
			g_object_set_data(G_OBJECT(dialog), objectkey, gpointer (radioand));

			radiogrp = gtk_radio_button_get_group(GTK_RADIO_BUTTON(radioand));
			
			GtkWidget *radioor = gtk_radio_button_new_with_label(radiogrp, _("or"));
			radiogrp = gtk_radio_button_get_group(GTK_RADIO_BUTTON(radioor));

			objectkey[Column]++;
			g_object_set_data(G_OBJECT(dialog), objectkey, gpointer (radioor));
			
			gtk_widget_set_sensitive (radioand, FALSE);
			gtk_widget_set_sensitive (radioor, FALSE);
			
			gtk_table_attach(GTK_TABLE(advpage), radioand, 
				0, 1, i, i+1, 
				GTK_FILL, GTK_EXPAND, 0, 0);
			gtk_table_attach(GTK_TABLE(advpage), radioor, 
				1, 2, i, i+1,
				GTK_FILL, GTK_EXPAND, 0, 0);
		}
		else
		{
			g_object_set_data(G_OBJECT(dialog), objectkey, gpointer (NULL));
			
			objectkey[Column]++;
			g_object_set_data(G_OBJECT(dialog), objectkey, gpointer (NULL));
		}

		optmenu = gtk_option_menu_new();
		if (i != 0) gtk_widget_set_sensitive (optmenu, FALSE);
		
		objectkey[Column]++;
		g_object_set_data(G_OBJECT(dialog), objectkey, gpointer (optmenu));
		
		itemfact = gtk_item_factory_new (GTK_TYPE_MENU, "<main>", NULL);
		gtk_item_factory_create_items_ac (itemfact, ncatpkgoptmnulbls, catpkgoptmnulbls, this, 1);
		
		optmenu_mnu = gtk_item_factory_get_widget (itemfact, "<main>");
		gtk_option_menu_set_menu(GTK_OPTION_MENU(optmenu), optmenu_mnu);
		gtk_option_menu_set_history(GTK_OPTION_MENU(optmenu), 0);
		gtk_table_attach(GTK_TABLE(advpage), optmenu, 
			2, 3, i, i+1, 
			GTK_FILL, GTK_EXPAND, 0, 0);

		
		optmenu = gtk_option_menu_new();
		gtk_widget_set_sensitive (optmenu, FALSE);
		
		objectkey[Column]++;
		g_object_set_data(G_OBJECT(dialog), objectkey, gpointer (optmenu));
		
		itemfact = gtk_item_factory_new (GTK_TYPE_MENU, "<main>", NULL);
		g_object_set_data(G_OBJECT(optmenu), "itemfactory", gpointer(itemfact));
		gtk_item_factory_create_items_ac (itemfact, ncatopoptmnulbls, catopoptmnulbls, this, 1);

		optmenu_mnu = gtk_item_factory_get_widget (itemfact, "<main>");

		gtk_option_menu_set_menu(GTK_OPTION_MENU(optmenu), optmenu_mnu);
		gtk_option_menu_set_history(GTK_OPTION_MENU(optmenu), 0);
		gtk_table_attach(GTK_TABLE(advpage), optmenu, 
			3, 4, i, i+1,
			GTK_FILL, GTK_EXPAND, 0, 0);

		chkbtn = gtk_check_button_new_with_label (_("Inv."));
		gtk_widget_set_sensitive (chkbtn, FALSE);
		
		objectkey[Column]++;
		g_object_set_data(G_OBJECT(dialog), objectkey, gpointer (chkbtn));
		
		gtk_table_attach(GTK_TABLE(advpage), chkbtn, 
			4, 5, i, i+1, 
			GTK_EXPAND, GTK_EXPAND, 0, 0);
	}
	
	
	
	// Second page -- Advanced search
	objectkey[Notebook] = '1';
	
	advpage = gtk_table_new(6, 5, FALSE);
	gtk_container_add(GTK_CONTAINER(notebook), advpage);

	gtk_notebook_set_tab_label(GTK_NOTEBOOK(notebook), 
		gtk_notebook_get_nth_page(GTK_NOTEBOOK(notebook), 1),
		gtk_label_new(_("Text filter ")));

	// create the field option menus
	for (int i = 0; i < 6; i++) {
		objectkey[Row] = i + '0';
		objectkey[Column] = '0';
		
		if (i != 0) {
			for (int j = 0; j < ntxtpkgoptmnulbls; j++) txtpkgoptmnulbls[j].callback_action++; 
			for (int j = 0; j < ntxtopoptmnulbls; j++)	txtopoptmnulbls[j].callback_action++; 
			
			GSList *radiogrp = NULL;
			GtkWidget *radioand = gtk_radio_button_new_with_label(NULL, _("and"));
			
			g_object_set_data(G_OBJECT(dialog), objectkey, gpointer (radioand));
			
			radiogrp = gtk_radio_button_get_group(GTK_RADIO_BUTTON(radioand));
			
			GtkWidget *radioor = gtk_radio_button_new_with_label(radiogrp, _("or"));
			radiogrp = gtk_radio_button_get_group(GTK_RADIO_BUTTON(radioor));

			objectkey[Column]++;
			g_object_set_data(G_OBJECT(dialog), objectkey, gpointer (radioor));
			
			gtk_widget_set_sensitive (radioand, FALSE);
			gtk_widget_set_sensitive (radioor, FALSE);
			
			gtk_table_attach(GTK_TABLE(advpage), radioand, 
				0, 1, i, i+1, 
				GTK_EXPAND, GTK_EXPAND, 0, 0);
			gtk_table_attach(GTK_TABLE(advpage), radioor, 
				1, 2, i, i+1,
				GTK_EXPAND, GTK_EXPAND, 0, 0);
		}
		else
		{
			g_object_set_data(G_OBJECT(dialog), objectkey, gpointer (NULL));
			
			objectkey[Column]++;
			g_object_set_data(G_OBJECT(dialog), objectkey, gpointer (NULL));
		}

		optmenu = gtk_option_menu_new();
		if (i != 0) gtk_widget_set_sensitive (optmenu, FALSE);
		
		objectkey[Column]++;
		g_object_set_data(G_OBJECT(dialog), objectkey, gpointer (optmenu));
		
		itemfact = gtk_item_factory_new (GTK_TYPE_MENU, "<main>", NULL);
		gtk_item_factory_create_items_ac (itemfact, ntxtpkgoptmnulbls, txtpkgoptmnulbls, this, 1);

		optmenu_mnu = gtk_item_factory_get_widget (itemfact, "<main>");
		
		gtk_option_menu_set_menu(GTK_OPTION_MENU(optmenu), optmenu_mnu);
		gtk_option_menu_set_history(GTK_OPTION_MENU(optmenu), 0);
		gtk_table_attach(GTK_TABLE(advpage), optmenu, 
			2, 3, i, i+1, 
			GTK_EXPAND, GTK_EXPAND, 0, 0);

		optmenu = gtk_option_menu_new();
		gtk_widget_set_sensitive (optmenu, FALSE);
		
		objectkey[Column]++;
		g_object_set_data(G_OBJECT(dialog), objectkey, gpointer (optmenu));
		
		itemfact = gtk_item_factory_new (GTK_TYPE_MENU, "<main>", NULL);
		gtk_item_factory_create_items_ac (itemfact, ntxtopoptmnulbls, txtopoptmnulbls, this, 1);

		optmenu_mnu = gtk_item_factory_get_widget (itemfact, "<main>");

		gtk_option_menu_set_menu(GTK_OPTION_MENU(optmenu), optmenu_mnu);
		gtk_option_menu_set_history(GTK_OPTION_MENU(optmenu), 0);
		gtk_table_attach(GTK_TABLE(advpage), optmenu, 
			3, 4, i, i+1,
			GTK_EXPAND, GTK_EXPAND, 0, 0);

		GtkWidget *entry = gtk_entry_new_with_max_length (255);
		gtk_widget_set_sensitive (entry, FALSE);
//		g_signal_connect(G_OBJECT(entry), "activate",
//			G_CALLBACK(SearchRun), (gpointer)this);
		
		objectkey[Column]++;
		g_object_set_data(G_OBJECT(dialog), objectkey, gpointer (entry));
		
		gtk_table_attach(GTK_TABLE(advpage), entry,
			4, 5, i, i+1, 
			(GtkAttachOptions)(GTK_EXPAND | GTK_FILL), 
			GTK_EXPAND, 0, 0);
	}

	
	GtkWidget *dlgactarea = GTK_DIALOG(dialog)->action_area;

	gtk_container_set_border_width(GTK_CONTAINER(dlgactarea), 10);
	GtkWidget *btnOK = gtk_button_new_with_label(_("OK"));
	gtk_box_pack_start(GTK_BOX(dlgactarea), btnOK, FALSE, TRUE, 0);
	GtkWidget *btnCancel = gtk_button_new_with_label(_("Cancel"));
	gtk_box_pack_start(GTK_BOX(dlgactarea), btnCancel, FALSE, TRUE, 0);

	g_signal_connect(G_OBJECT(btnOK), "clicked",
		G_CALLBACK(DoOK), (gpointer)this);
	g_signal_connect(G_OBJECT(btnCancel), "clicked",
		G_CALLBACK(DoCancel), (gpointer)this);

	return dialog;

// testing other solution
/*
	GtkWidget *dlg;
	GtkWidget *butvbox, *hbox;
//	GtkWidget *leftbutton, *rightbutton;
	GtkWidget *btnok, *btncancel;
	GtkTreeSelection *select;
	GtkCellRenderer *renderer;
	GtkTreeViewColumn *column;
	GtkTreeIter iter;

	// Create all the widgets
	dlg = gtk_dialog_new();
	gtk_window_set_resizable (GTK_WINDOW(dlg), FALSE);
	gtk_window_set_title(GTK_WINDOW(dlg), _("Filtering Options"));
	gtk_window_set_position (GTK_WINDOW(dlg), GTK_WIN_POS_CENTER);
	gtk_window_set_default_size (GTK_WINDOW(dlg), _Conf.GetInt("edeity.gtk.window.filterselect.xsize"), _Conf.GetInt("edeity.gtk.window.filterselect.ysize"));
//old	gtk_widget_set_usize(GTK_WIDGET(dlg), _Conf.GetInt("edeity.gtk.window.filterselect.xsize"), _Conf.GetInt("edeity.gtk.window.filterselect.ysize"));
//old	gtk_widget_set_size_request(GTK_WIDGET(dlg), _Conf.GetInt("edeity.gtk.window.filterselect.xsize"), _Conf.GetInt("edeity.gtk.window.filterselect.ysize"));
	hbox = gtk_hbox_new(FALSE, 0);
	butvbox = gtk_vbox_new(FALSE, 0);
//old	baselist = gtk_clist_new(1);
	baseliststore = gtk_list_store_new(1, G_TYPE_STRING);
	for (int k = 0; k < NUM_FILTER_TYPES; k++)
	{
	    gtk_list_store_append(baseliststore, &iter);
	    gtk_list_store_set(baseliststore, &iter, 0, filterlabels[k], -1);
	}
	baselist = gtk_tree_view_new_with_model (GTK_TREE_MODEL(baseliststore));
	select = gtk_tree_view_get_selection (GTK_TREE_VIEW(baselist));
	gtk_tree_selection_set_mode (select, GTK_SELECTION_MULTIPLE);
	
	renderer = gtk_cell_renderer_text_new ();
	column = gtk_tree_view_column_new_with_attributes (_("Filters"), renderer, "text", 0, NULL);
	gtk_tree_view_column_set_min_width (column, 150);
	
	gtk_tree_view_append_column (GTK_TREE_VIEW (baselist), column);
//old	targetlist = gtk_clist_new(1);
//old	leftbutton = gtk_button_new_with_label("<-");
//old	rightbutton = gtk_button_new_with_label("->");
	filtertext = gtk_entry_new();
	btnok = gtk_button_new_with_label(_("OK"));
	btncancel = gtk_button_new_with_label(_("Cancel"));

	// setup the filter lists
//old	gtk_clist_set_shadow_type(GTK_CLIST(baselist), GTK_SHADOW_OUT);
//old	gtk_clist_set_shadow_type(GTK_CLIST(targetlist), GTK_SHADOW_OUT);
	
	// lay them out
//old	gtk_box_pack_start(GTK_BOX(butvbox), leftbutton, TRUE, FALSE, 10);
//old	gtk_box_pack_start(GTK_BOX(butvbox), rightbutton, TRUE, FALSE, 10);

	gtk_box_pack_start(GTK_BOX(hbox), baselist, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(hbox), butvbox, FALSE, FALSE, 10);
//old	gtk_box_pack_start(GTK_BOX(hbox), targetlist, TRUE, TRUE, 0);

	gtk_container_set_border_width(GTK_CONTAINER(dlg), 20);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dlg)->vbox), hbox, TRUE, TRUE, 10);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dlg)->vbox), gtk_label_new(_("Text to look for:")), FALSE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dlg)->vbox), filtertext, FALSE, FALSE, 0);

	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dlg)->action_area), btnok, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dlg)->action_area), btncancel, TRUE, TRUE, 0);

	// Connect the signals
//old	gtk_signal_connect(GTK_OBJECT(btnok), "clicked",
//old		GTK_SIGNAL_FUNC(DoOK), (gpointer)this);
	g_signal_connect(G_OBJECT(btnok), "clicked",
			 G_CALLBACK(DoOK), (gpointer)this);
//old	gtk_signal_connect(GTK_OBJECT(btncancel), "clicked",
//old	GTK_SIGNAL_FUNC(DoCancel), (gpointer)this);
	g_signal_connect(G_OBJECT(btncancel), "clicked",
			 G_CALLBACK(DoCancel), (gpointer)this);
//old	gtk_signal_connect(GTK_OBJECT(baselist), "select-row",
//old		GTK_SIGNAL_FUNC(SelectRow), (gpointer)this);
//old	gtk_signal_connect(GTK_OBJECT(baselist), "unselect-row",
//old		GTK_SIGNAL_FUNC(UnselectRow), (gpointer)this);
//old	gtk_signal_connect(GTK_OBJECT(targetlist), "select-row",
//old			 G_CALLBACK(SelectRow), (gpointer)this);
//old	gtk_signal_connect(GTK_OBJECT(targetlist), "unselect-row",
//old		GTK_SIGNAL_FUNC(UnselectRow), (gpointer)this);
//old	gtk_signal_connect(GTK_OBJECT(leftbutton), "clicked",
//old		GTK_SIGNAL_FUNC(DoRemove), (gpointer)this);
//old	gtk_signal_connect(GTK_OBJECT(rightbutton), "clicked",
//old		GTK_SIGNAL_FUNC(DoAdd), (gpointer)this);

	return dlg;

	/*
	gtk_widget_set_sensitive(btnRemove, FALSE);
	*/
}
/*old
void GtkUI::FilterEditor::UpdateLists()
{
	GtkTreeIter iter;

	gtk_clist_freeze(GTK_CLIST(baselist));
	gtk_clist_freeze(GTK_CLIST(targetlist));
	gtk_clist_clear(GTK_CLIST(baselist));
	gtk_clist_clear(GTK_CLIST(targetlist));
	for (int k = 0; k < NUM_FILTER_TYPES; k++)
	{
		if (baseselected[k])
		{
		    gtk_clist_append(GTK_CLIST(baselist), &filterlabels[k]);
		}
		if (targetselected[k])
		{
		    gtk_clist_append(GTK_CLIST(targetlist), &filterlabels[k]);
		}
	}
	gtk_clist_thaw(GTK_CLIST(baselist));
	gtk_clist_thaw(GTK_CLIST(targetlist));
}
*/
bool GtkUI::FilterEditor::Run()
{
//old	UpdateLists();
	gtk_widget_show_all(dialog);
	gtk_main();
	INFO(INFO_DEBUG, _("Closing filter editor window; cancelled = %s\n"),
		cancelled ? _("true") : _("false"));
	return !cancelled;
}

void GtkUI::FilterEditor::DoOK(GtkWidget *, gpointer data)
{
	GtkTreeIter iter;
	GtkTreeSelection *select;
	bool next;

	GtkUI::FilterEditor *This = (GtkUI::FilterEditor *)data;
	
	
/*old	
	select = gtk_tree_view_get_selection (GTK_TREE_VIEW(This->baselist));
	gtk_tree_model_get_iter_first (GTK_TREE_MODEL(This->baseliststore), &iter);
	
	for (int row = 0; next; row++)
	{
	    This->targetselected[row] = gtk_tree_selection_iter_is_selected (select, &iter);
    	    next = gtk_tree_model_iter_next (GTK_TREE_MODEL(This->baseliststore), &iter);
	}
*/

	gtk_main_quit();
	This->cancelled = false;
}

void GtkUI::FilterEditor::DoCancel(GtkWidget *, gpointer data)
{
	GtkUI::FilterEditor *This = (GtkUI::FilterEditor *)data;
	
	gtk_main_quit();
	This->cancelled = true;
}

void GtkUI::FilterEditor::filter_list_create()
{
	pkgCache::Package ** SortedPkgs = new pkgCache::Package *[(*Cache)->Head().PackageCount + 1];
	SortOrderList::method_t FilterType = GetFilterType();
	SortOrderList::Comparer *Comparer = screen.Packages->Sorting->GetComparer(FilterType, false);
	
	unsigned int J = screen.Packages->collect_packages (SortedPkgs);
	const char **values = NULL;
	int nvalue = 0;

	qsort(SortedPkgs, J, sizeof(*SortedPkgs), Comparer);
	
	for (int i = 0; i < J; i++)
		if (Comparer (&SortedPkgs[i], &SortedPkgs[i+1]) || ((i == J - 1) && (nvalue == 0)))
		{
			pkgCache::PkgIterator Iter(*Cache, SortedPkgs[i]);
			pkgCache::VerIterator Vers = Iter.VersionList();

			values = (const char **) realloc (values, (nvalue + 1) * sizeof  (char *));
			
			switch (FilterType)
			{
			case SortOrderList::Section:
				values [nvalue] = (Cache->GetCache()->StrP + SortedPkgs[i]->Section);
			break;
			
			case SortOrderList::Priority:
				values [nvalue] = Vers.PriorityType();
			break;
			
			case SortOrderList::Status:			
				values [nvalue] = ((*Cache)[Iter].Status == 1 ? _("Installed") : (((*Cache)[Iter].InstVerIter(*Cache).end() == false || (*Cache)[Iter].Delete() == true) && (*Cache)[Iter].NewInstall() == false ? _("Upgraded") : _("Kept")));			
			break;
			
			case SortOrderList::SpecStat:			
				values [nvalue] = ((*Cache)[Iter].InstBroken()? _("Broken") : ((*Cache)[Iter].  NewInstall()? _("Install") : ((*Cache)[Iter].  Upgrade()?  _("Upgrade") : ((*Cache)[Iter].  Downgrade()?  _("Delete") : ((*Cache) [Iter].  Install()?  _("Install") : ( (*Cache) [Iter].  Delete ()? ( ( (*Cache) [Iter].  iFlags & pkgDepCache:: Purge) ? _("Purge") : _("Remove")) : ((*Cache)[Iter].iFlags & pkgDepCache::ReInstall) ? _("Reinstall") : _("Keep")))))));
			break;
			
			case SortOrderList::Dep:			
				values [nvalue] = Vers.DependsList().end() ? _("Non-dependent") : _("Dependent");
			break;
			
			case SortOrderList::RevDep:			
				values [nvalue] = Iter.RevDependsList().end() ? _("Non-referred") : _("Referred");
			break;
			}
			nvalue++;
		}

	UpdateFilterMenu(values, nvalue);
	
	delete [] SortedPkgs;
	delete [] values;
}


void GtkUI::FilterEditor::MenuChange(gpointer data, guint num, GtkWidget *optmenuitem)
{
	GtkUI::FilterEditor *This = (GtkUI::FilterEditor *)data;

	gchar objectkey[nKey + 1] = "";
	for (int i = 0; i < nKey; i++) objectkey[nKey - i - 1] = ((num & (0x0000f << (i * 4))) >> (i * 4)) + '0';
	
	GtkWidget *widget = GTK_WIDGET (g_object_get_data(G_OBJECT(This->dialog), objectkey));
	g_object_set_data(G_OBJECT(This->dialog), "changedmenu", gpointer (widget));
	
	gboolean sens = gtk_option_menu_get_history (GTK_OPTION_MENU (widget));

	if (sens)
	{
		switch (objectkey[Column]) {
		case '3': 
			objectkey[Column]--; objectkey[Row]++;
			widget = GTK_WIDGET (g_object_get_data(G_OBJECT(This->dialog), objectkey));
			gtk_widget_set_sensitive (widget, sens);
			
			objectkey[Row]--;
			for (objectkey[Column] = (objectkey[Row] == '0') ? '2' : '0'; objectkey[Column] < '5'; objectkey[Column]++)	
			{
				widget = GTK_WIDGET (g_object_get_data(G_OBJECT(This->dialog), objectkey));
				gtk_widget_set_sensitive (widget, sens);
			}
		break;
		
		case '2':
			for (; objectkey[Column] < '5'; objectkey[Column]++)	
			{
				widget = GTK_WIDGET (g_object_get_data(G_OBJECT(This->dialog), objectkey));
				gtk_widget_set_sensitive (widget, sens);
			}
			
			if (objectkey[Notebook] == '0') 
				This->filter_list_create();
		break;
		}
	}
	else
	{
		gchar row;
	
		for (row = objectkey[Row]; objectkey[Row] < '6'; objectkey[Row]++)	
			for (objectkey[Column] = '0'; objectkey[Column] < '5'; objectkey[Column]++)	
			{
				widget = GTK_WIDGET (g_object_get_data(G_OBJECT(This->dialog), objectkey));
				if (widget) gtk_widget_set_sensitive (widget, sens);
			}

		objectkey[Row] = row; objectkey[Column] = '2';
		widget = GTK_WIDGET (g_object_get_data(G_OBJECT(This->dialog), objectkey));
		gtk_widget_set_sensitive (widget, TRUE);
		
		if (objectkey[Row] == '3')
		{
			objectkey[Row]++;
			widget = GTK_WIDGET (g_object_get_data(G_OBJECT(This->dialog), objectkey));
			gtk_widget_set_sensitive (widget, TRUE);
		}
	}
}

//old void GtkUI::FilterEditor::GetFilter(char *&txt, Filter::Target &target)
void GtkUI::FilterEditor::GetFilter(char **buf, unsigned long *target)
{	
	GtkWidget* notebook = GTK_WIDGET (g_object_get_data(G_OBJECT(dialog), "notebook"));
	
	gchar objectkey[nKey + 1] = "";
	objectkey[Notebook] = '0' + gtk_notebook_get_current_page (GTK_NOTEBOOK (notebook));
	
	GtkWidget *widget[NRow];
	
	for (int i = 0; i < 6; i++)
	{
		objectkey[Row] = '0' + i;
		
		for (int j = 0; j < 5; j++)
		{
			objectkey[Column] = '0' + j;
			widget[j] = (GtkWidget *) g_object_get_data(G_OBJECT(dialog), objectkey);
		}
		
		if (objectkey[Notebook] == '0')
		{
			const gchar *key = NULL;
			GtkWidget *menuitem;
			GtkItemFactory *itemfact = GTK_ITEM_FACTORY (g_object_get_data(G_OBJECT(widget [OptMenu]), "itemfactory"));

	    	switch (gtk_option_menu_get_history (GTK_OPTION_MENU(widget[Menu])) - 1)
		    {
			case 0: target[i] |= Pkg_Status;
			break;
			case 1: target[i] |= Pkg_SpecStatus;
			break;
			case 2: target[i] |= Pkg_Section;
			break;
			case 3: target[i] |= Pkg_Priority;
			break;
//			case 4: target[i] |= Pkg_Suite;
//			break;
			case 4: target[i] |= Pkg_Dep;
			break;
			case 5: target[i] |= Pkg_RevDep;
			break;
		    }
			
			for (int num = 0;
				 num = gtk_option_menu_get_history (GTK_OPTION_MENU (widget[OptMenu]));
				 gtk_widget_destroy (menuitem))
			{	
				menuitem = gtk_item_factory_get_item_by_action (itemfact, 0x030 + objectkey[Row] - '0');
				key = strchr (gtk_widget_get_name (menuitem), '/') + 1;
			}
			
			buf[i] = strdup (key ? key : "");
			
			if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (widget[Extra])))
			    target[i] |= Cmp_NEq;
			else
			    target[i] |= Cmp_Eq;
				
		}    
		else
		{
			buf[i] = strdup(gtk_entry_get_text(GTK_ENTRY(widget[Extra])));
		    
		    switch (gtk_option_menu_get_history (GTK_OPTION_MENU(widget[OptMenu])) - 1)
		    {
			case 0:	target[i] |= Cmp_Eq;
			break;
			case 1: target[i] |= Cmp_NEq;
			break;
			case 2: target[i] |= Cmp_Less;
			break;
			case 3: target[i] |= Cmp_Great;
			break;
			case 4: target[i] |= Cmp_Cont;
			break;
			case 5: target[i] |= Cmp_NCont;
			break;
	    	}
		
	    	switch (gtk_option_menu_get_history (GTK_OPTION_MENU(widget[Menu])) - 1)
		    {
			case 0: target[i] |= Pkg_Name;
			break;
			case 1: target[i] |= Pkg_AvailVer;
			break;
			case 2: target[i] |= Pkg_InstlVer;
			break;
			case 3: target[i] |= Pkg_Maintainer;
			break;
			case 4: target[i] |= Pkg_FileName;
			break;
			case 5: target[i] |= Pkg_ShortDesc;
			break;
			case 6: target[i] |= Pkg_LongDesc;
			break;
		    }
		}
		
	    if (i)
	    {
			if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (widget[And])))
			    target[i] |= Cmp_And;
			else
			    target[i] |= Cmp_Or;
		}
		else
	    {
		target[i] |= Cmp_Or;
		}
	}	
	
/*	int targ = 0;
	gchar *tmp = (gchar *) gtk_entry_get_text(GTK_ENTRY(filtertext));
	if (tmp == NULL)
		txt = strdup("");
	else
		txt = strdup(tmp);

	if (targetselected[0])
		targ |= Filter::pkgname;
	if (targetselected[1])
		targ |= Filter::pkgavailver;
	if (targetselected[2])
		targ |= Filter::pkginstlver;
	if (targetselected[3])
		targ |= Filter::pkgsection;
	if (targetselected[4])
		targ |= Filter::pkgpriority;
	if (targetselected[5])
		targ |= Filter::pkgshortdesc;
	if (targetselected[6])
		targ |= Filter::pkglongdesc;
	target = Filter::Target(targ);

*/
}

void GtkUI::FilterEditor::UpdateFilterMenu(const char **values, int nvalue)
{
	gchar objectkey[] = "020";
	gchar buff[64];
	gchar *key;

	GtkWidget *optmenu;
	GtkWidget *menuitem;
	
	GtkItemFactory *itemfact;
	GtkItemFactoryEntry *item;
	
	for (optmenu = GTK_WIDGET (g_object_get_data(G_OBJECT (dialog), "changedmenu"));
		 optmenu != GTK_WIDGET (g_object_get_data(G_OBJECT (dialog), objectkey));
		 objectkey[Row]++);
	
	objectkey[Column]++;
	optmenu = GTK_WIDGET (g_object_get_data(G_OBJECT (dialog), objectkey));
	
	itemfact = GTK_ITEM_FACTORY (g_object_get_data(G_OBJECT(optmenu), "itemfactory"));

	for (;menuitem = gtk_item_factory_get_item_by_action (itemfact, 0x030 + objectkey[Row] - '0');)
		gtk_widget_destroy (menuitem);

	item = g_new0(GtkItemFactoryEntry, 1);
	item->path = _("/Choose category");
	item->accelerator = NULL;
	item->callback = GtkItemFactoryCallback (MenuChange);
	item->callback_action = 0x030 + objectkey[Row] - '0';
	item->item_type = "<Item>";

	gtk_item_factory_create_items (itemfact, 1, item, this);
 
	for (int i = 0; i < nvalue; i++)
	{
		sprintf (buff, "/%s", values[i]);
		for (key = buff + 1; key = strchr (key, '/'); key++) *key = ':';
		
		item->path = strdup (buff);
		
		gtk_item_factory_create_items (itemfact, 1, item, this);
	}

	gtk_option_menu_set_history (GTK_OPTION_MENU (optmenu), 0);

}

SortOrderList::method_t GtkUI::FilterEditor::GetFilterType()
{
	GtkWidget *opt_menu = GTK_WIDGET (g_object_get_data(G_OBJECT (dialog), "changedmenu"));

	switch (gtk_option_menu_get_history (GTK_OPTION_MENU (opt_menu)))
	{
	case 1:
		return SortOrderList::Status;
	case 2:
		return SortOrderList::SpecStat;
	case 3:
		return SortOrderList::Section;
	case 4:
		return SortOrderList::Priority;
//	case 5:
//		return SortOrderList::Suite;
	case 5:
		return SortOrderList::Dep;
	case 6:
		return SortOrderList::RevDep;
	}
}

/*old
void GtkUI::FilterEditor::SelectRow(GtkCList *clist, gint row, gint col,
	GdkEventButton *event, gpointer data)
void GtkUI::FilterEditor::SelectRow(GtkWidget *List, gpointer data)
{
	GtkTreeSelection *select;
	GtkTreeModel *model;
	GtkTreeIter iter;

	GtkUI::FilterEditor *This = (GtkUI::FilterEditor *)data;
	gchar *text = 0;
	int r = 0;

//old	gtk_clist_get_text(clist, row, col, &text);
	select = gtk_tree_view_get_selection (GTK_TREE_VIEW(List));
	gtk_tree_selection_get_selected (select, &model, &iter);
        gtk_tree_model_get (model, &iter, 0, &text, -1);
	
	INFO(INFO_DEBUG, "selected text is \"%s\"\n", text);
	for (; r < NUM_FILTER_TYPES; r++)
		if (strcmp(text, filterlabels[r]) == 0)
			break;

	if (r == NUM_FILTER_TYPES)
		return;

//old	if (clist == GTK_CLIST(This->baselist))
	if (List == This->baselist)
		This->baserow = r;
//old	else if (clist == GTK_CLIST(This->targetlist))
	else if (List == This->targetlist)
		This->targetrow = r;
}

void GtkUI::FilterEditor::UnselectRow(GtkCList *clist, gint row, gint col,
	GdkEventButton *event, gpointer data)
void GtkUI::FilterEditor::UnselectRow(GtkWidget *List, gpointer data)
{
	GtkUI::FilterEditor *This = (GtkUI::FilterEditor *)data;
//old	if (clist == GTK_CLIST(This->baselist))
	if (List == This->baselist)
		This->baserow = -1;
//old	else if (clist == GTK_CLIST(This->targetlist))
	else if (List == This->targetlist)
		This->targetrow = -1;
}

void GtkUI::FilterEditor::DoAdd(GtkWidget *, gpointer data)
{
	GtkUI::FilterEditor *This = (GtkUI::FilterEditor *)data;
	if (This->baserow < 0) return;
	This->baseselected[This->baserow] = false;
	This->targetselected[This->baserow] = true;
	This->UpdateLists();
}

void GtkUI::FilterEditor::DoRemove(GtkWidget *, gpointer data)
{
	GtkUI::FilterEditor *This = (GtkUI::FilterEditor *)data;
	if (This->targetrow < 0) return;
	This->baseselected[This->targetrow] = true;
	This->targetselected[This->targetrow] = false;
	This->UpdateLists();
}
*/
