/* $Id: menu.h,v 1.5 2001/05/02 15:17:38 ltd Exp $ */
#ifndef _gtkui_menu_H
#define _gtkui_menu_H

//old #include <std.h>

#define MENU_SECTIONS(caption, key) \
	{ caption, key, 0, "<Branch>", 0, 0 }
#define MENU_ITEM(caption, key, func) \
	{ caption, key, 0, 0, func, 0 }
#define MENU_UITEM(caption, key, func) \
	{ caption, key, 2, 0, 0, &GtkUI::Screen::func }
#define MENU_CHK(caption, key, func) \
	{ caption, key, 0, "<CheckItem>", func, 0 }

/*old
GtkUI::Screen::MenuItemEntry GtkUI::Screen::menu_items[] = {
  MENU_SECTIONS("/_File", "<control>F"),
  MENU_ITEM("/_File/Complete pending install and removals", NULL, DefaultKeys::complete_pending),
  MENU_UITEM("/_File/Edit APT Sources", NULL, EditSources),
  MENU_ITEM("/_File/Update avail. package lists", NULL, DefaultKeys::update_lists),
  MENU_ITEM("/_File/Reload disk package cache", NULL, DefaultKeys::reread_cache),
  { "/_File/sep1",		NULL,	0,	"<Separator>", 0, 0 },
  MENU_ITEM("/_File/Quit", "q", DefaultKeys::quit),

  MENU_SECTIONS("/_Edit", "<control>E"),
  MENU_ITEM("/_Edit/Locate package", NULL, DefaultKeys::search),
  MENU_UITEM("/_Edit/Next match", "n", SeekNextMatched),
  MENU_UITEM("/_Edit/Prev match", "p", SeekPrevMatched),
  MENU_UITEM("/_Edit/First match", "f", SeekFirstMatched),
  MENU_UITEM("/_Edit/Last match", "l", SeekLastMatched),
  MENU_ITEM("/_Edit/Reset search items", "<control>R", DefaultKeys::reset_markers),


  MENU_SECTIONS("/_Movement", "<control>M"),
  MENU_ITEM("/_Movement/Move to the next package", NULL, 0),
  MENU_ITEM("/_Movement/Move to the previous package", NULL, 0),
  MENU_ITEM("/_Movement/Move to the start of the list", NULL, 0),
  MENU_ITEM("/_Movement/Move to the end of the list", NULL, 0),
  MENU_ITEM("/_Movement/Move down one screen length", NULL, 0),
  MENU_ITEM("/_Movement/Move up one screen length", NULL, 0),


  MENU_SECTIONS("/_Toggle", "<control>T"),
  MENU_ITEM("/_Toggles/Description window", NULL, DefaultKeys::descwin_toggle),
  MENU_ITEM("/_Toggle/Verbose tree view", NULL, DefaultKeys::viewmode_toggle),

  MENU_SECTIONS("/_Command", "<control>C"),
  MENU_ITEM("/_Command/Hold package", NULL, DefaultKeys::pkg_hold),
  MENU_ITEM("/_Command/Mark pkg for install or upgrade (*)", NULL, DefaultKeys::pkg_install),
  MENU_ITEM("/_Command/Mark pkg for remove (*)", NULL, DefaultKeys::pkg_remove),
  MENU_ITEM("/_Command/Mark pkg for purge (*)", NULL, DefaultKeys::pkg_purge),
  MENU_ITEM("/_Command/Upgrade all possible", NULL, DefaultKeys::all_upgrade),
  MENU_ITEM("/_Command/Upgrade distribution", NULL, DefaultKeys::dist_upgrade),
  MENU_ITEM("/_Command/Expand package dependencies (*)", NULL, DefaultKeys::depend_toggle),

  MENU_SECTIONS("/_Filter", "<control>F"),
  MENU_ITEM("/_Filter/Add new filter", NULL, filter_add_single),
  MENU_ITEM("/_Filter/Remove active filters", NULL, filter_revoke_all),
  MENU_ITEM("/_Filter/Display active filters", NULL, filter_display_all),
  MENU_ITEM("/_Filter/Invert filter polarity", NULL, filter_change_view),

  MENU_SECTIONS("/_Sorting", "<control>S"),
  MENU_UITEM("/_Sorting/Tree sorting method(s)", NULL, SortSelectMethod),
  MENU_UITEM("/_Sorting/Tree column sorting", NULL, ColumnSelectMethod),

  MENU_CHK("/_Sorting/Section", NULL, 0),
  MENU_CHK("/_Sorting/Priority", NULL, 0),
  MENU_CHK("/_Sorting/State", NULL, 0),
  MENU_CHK("/_Sorting/Package name", NULL, 0),
  MENU_CHK("/_Sorting/Archive size", NULL, 0),
  MENU_CHK("/_Sorting/Install size", NULL, 0),
	
  { "/_Help",		"<control>H",	0,	"<LastBranch>", 0, 0 },
  MENU_ITEM("/_Help/About", NULL, MnuAbout),
  MENU_UITEM("/_Help/Key Bindings", "?", HelpDialog)
};
*/
#endif
