/* $Id: sortcol.h,v 1.3 2003/01/27 14:56:21 ltd Exp $ */
#ifndef _gtkui_sortcol_H
#define _gtkui_sortcol_H

#include "gtkui.h"

class GtkUI::SortCol
{
protected:
	GtkUI::Screen &screen;

	GtkWidget *window;
	GtkWidget *srclist;
	GtkWidget *dstlist;
	GtkListStore *srcliststore;
	GtkListStore *dstliststore;

	enum
	{
	    Name_Col,
	    Num_Col,
	    Color_Col,
	    N_Col
	};
	
	static void AddMethod(GtkWidget *, gpointer);
	static void RemoveMethod(GtkWidget *, gpointer);
	static void MoveUp(GtkWidget *, gpointer);
	static void MoveDown(GtkWidget *, gpointer);
	static void Apply(GtkWidget *, gpointer);
	static void Cancel(GtkWidget *, gpointer);
	
	static void DragAndDrop (GtkWidget *, GdkDragContext *, gint, gint, GtkSelectionData *, guint, guint, gpointer);
	
public:
	SortCol(GtkUI::Screen &);
	~SortCol();

	void Show();
};

#endif
