/* $Id: srcedit.h,v 1.3 2000/11/17 14:56:21 ltd Exp $ */
#ifndef _gtkui_srcedit_H
#define _gtkui_srcedit_H

#include "gtkui.h"

#include <list/sources.h>

class GtkUI::SrcEditor {
	GtkUI::Screen &screen;
	SourcesList lst;
	
	enum columns {
		Active_Col,
		DebType_Col,
		URI_Col,
		Distrib_Col,
		Section_Col,
		Color_Col,
		SrcRec_Col,
		ColumnNum
	};

	GtkWidget *dialog;
	GtkWidget *lstSources;
	GtkWidget *entryURI;
	GtkWidget *entrySect;
	GtkWidget *optType;
	GtkWidget *optTypeMenu;
	GtkWidget *comDistEntry;
	GtkWidget *cbDisabled;
	GtkWidget *cbMain;
	GtkWidget *cbContrib;
	GtkWidget *cbNonFree;
	GtkWidget *cbNonUS;
	
	GtkListStore* lstSourcesstore;
	
	bool isRoot;
//	int selectedrow;

	GtkWidget *CreateWidget();


	// static event handlers
	static void DoAdd(GtkWidget *, gpointer);
	static void DoEdit(GtkWidget *, gpointer);
	static void DoRemove(GtkWidget *, gpointer);
	static void DoOK(GtkWidget *, gpointer);
	static void DoCancel(GtkWidget *, gpointer);
//old	static void UpdateDisplay(GtkCList *, gint, gint, GdkEventButton *, gpointer);
	static void UpdateDisplay(GtkTreeSelection *, gpointer);
//old	static void UnselectRow(GtkCList *, gint, gint, GdkEventButton *, gpointer);

public:
	SrcEditor(GtkUI::Screen &);
	~SrcEditor();

	void Run();
};

#endif
