/* $Id: sections.cc,v 1.6 2000/11/17 14:56:21 ltd Exp $ */
#include <std.h>

#include "sections.h"

char *Section_Lookup(char *Name)
{

sectdesc_t Sections[] =
{
	{ _("alien"),           _("Packages that are not part of the standard distribution") },

	{ _("admin"),           _("Administration packages for super users") },
	{ _("base"),            _("Base packages for a normal installation") },
	{ _("comm"),            _("Communications packages; modem, packet radio, etc.") },
	{ _("devel"),           _("Development (languages, interpreters, compilers, libraries)") },
	{ _("doc"),             _("Documentation, manuals and other information") },
	{ _("editors"),         _("Text editors (console and X-based)") },
	{ _("electronics"),     _("Circuit and electronic related packages") },
	{ _("games"),           _("Entertainment packages for X11/console") },
	{ _("graphics"),        _("Graphical viewers and design programs") },
	{ _("hamradio"),        _("Amateur radio and related packages") },
	{ _("interpreters"),    _("Language interpreters (perl, python, pike, etc)") },
	{ _("libs"),            _("Common system and other shared libraries") },
	{ _("mail"),            _("Mail user (client apps) and transfer (server apps) agents") },
	{ _("math"),            _("Computation programs (calculators, education, etc)") },
	{ _("misc"),            _("Miscellaneous (Un-sectioned) Packages") },
	{ _("net"),             _("Networking packages (servers, clients)") },
	{ _("news"),            _("Usenet (NNTP/NNRP) client/servers") },
	{ _("oldlibs"),         _("Old shared libraries (libc5, defunct libs)") },
	{ _("otherosfs"),       _("Packages that deal with other operating or filing systems") },
	{ _("shells"),          _("Common shells (bash/csh/zsh/ash/etc)") },
	{ _("sound"),           _("Audio (music) applications") },
	{ _("tex"),             _("Various TEX implementations") },
	{ _("text"),            _("Applications that involve text processing or editing") },
	{ _("utils"),           _("Common utilities") },
	{ _("web"),             _("\\World Wide Web servers, browsers, and HTML pre-processors") },
	{ _("x11"),             _("X11 Windowing System and related games, utilities, helpers") },
	{ NULL,              NULL }
};

	for (sectdesc_t *X = Sections; X->Name != NULL; X++)
		if (strcmp(X->Name, Name) == 0)
			return X->Description;
			
	return Name;
}
