/* $Id: strutl.h,v 1.5 2001/06/22 14:59:17 ltd Exp $ */
#ifndef _strutl_H
#define _strutl_H

//old #define SEARCH_CASE	0x1
//old #define SEARCH_DESC	0x2
//old #define SEARCH_REGEX	0x4

#define		Pkg_Name			(1<<0) 
#define		Pkg_AvailVer			(1<<1) 
#define		Pkg_InstlVer			(1<<2) 
#define		Pkg_Maintainer			(1<<3)
#define		Pkg_FileName			(1<<4)
#define		Pkg_ShortDesc			(1<<5) 
#define		Pkg_LongDesc			(1<<6) 
#define		Pkg_Status			(1<<7)
#define		Pkg_SpecStatus			(1<<8)
#define		Pkg_Section			(1<<9)
#define		Pkg_Priority			(1<<10)
#define		Pkg_Suite			(1<<11)
#define		Pkg_Dep				(1<<12)
#define		Pkg_RevDep			(1<<13)
#define		Cmp_Eq				(1<<14)
#define		Cmp_NEq				(1<<15)
#define		Cmp_Less			(1<<16)
#define		Cmp_Great			(1<<17)
#define		Cmp_Cont			(1<<18)
#define		Cmp_NCont			(1<<19)
#define		Cmp_Or				(1<<20)
#define		Cmp_And				(1<<21)
#define		Cmp_Case			(1<<22)
#define		Cmp_Regex			(1<<23)

#include <regex.h>

char *period_string(const char *, unsigned);
void strlower(char *);
char *stripcolorcodes(const char *);
char *sane_strtok(char *, const char *);
void sane_strntrnc(char *, const char *, unsigned int);
//old int search_string(const char *haystack, char *needle, unsigned long options, regex_t * rectx);
int search_string(const char *haystack, char *needle, unsigned long options);
int get_line (FILE *, char* );

#endif /* _strutl_H */
